/*
 *         
 * $Id:$
 * 
 * $Copyright: (c) 2018 Broadcom.
 * Broadcom Proprietary and Confidential. All rights reserved.$
 *         
 *     
 * DO NOT EDIT THIS FILE!
 *
 */

#ifndef _PORTMOD_DISPATCH_H__H_
#define _PORTMOD_DISPATCH_H__H_

#include <phymod/phymod.h>
#include <phymod/phymod_diagnostics.h>
#include <phymod/phymod_reg.h>
#include <soc/cprimod/cprimod.h>
#include <soc/portmod/portmod_defs.h>
#include <soc/portmod/portmod.h>

typedef int (*__dispatch__portmod_port_speed_ability_local_get_f)(int unit, int port, pm_info_t pm_info, int max_num_abilities, portmod_port_speed_ability_t* abilities, int* num_abilities);
typedef int (*__dispatch__portmod_pm_interface_type_is_supported_f)(int unit, soc_port_if_t interface, int* is_supported);
typedef int (*__dispatch__portmod_pm_init_f)(int unit, const portmod_pm_create_info_internal_t* pm_add_info, int wb_buffer_index, pm_info_t pm_info);
typedef int (*__dispatch__portmod_pm_destroy_f)(int unit, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_attach_f)(int unit, int port, pm_info_t pm_info, const portmod_port_add_info_t* add_info);
typedef int (*__dispatch__portmod_default_bus_update_f)(int unit, pm_info_t pm_info, const portmod_bus_update_t* update);
typedef int (*__dispatch__portmod_pm_bypass_set_f)(int unit, pm_info_t pm_info, int enable);
typedef int (*__dispatch__portmod_pm_core_info_get_f)(int unit, pm_info_t pm_info, int phyn, portmod_pm_core_info_t* core_info);
typedef int (*__dispatch__portmod_pm_phys_get_f)(int unit, pm_info_t pm_info, portmod_pbmp_t* phys);
typedef int (*__dispatch__portmod_port_detach_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_replace_f)(int unit, int port, pm_info_t pm_info, int new_port);
typedef int (*__dispatch__portmod_port_enable_set_f)(int unit, int port, pm_info_t pm_info, int flags, int enable);
typedef int (*__dispatch__portmod_port_enable_get_f)(int unit, int port, pm_info_t pm_info, int flags, int* enable);
typedef int (*__dispatch__portmod_port_cdr_lock_get_f)(int unit, int port, pm_info_t pm_info, int* is_locked);
typedef int (*__dispatch__portmod_port_interface_config_set_f)(int unit, int port, pm_info_t pm_info, const portmod_port_interface_config_t* config, int phy_init_flags);
typedef int (*__dispatch__portmod_port_interface_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_port_interface_config_t* config, int phy_init_flags);
typedef int (*__dispatch__portmod_port_default_interface_get_f)(int unit, int port, pm_info_t pm_info, const portmod_port_interface_config_t* config, soc_port_if_t* interface);
typedef int (*__dispatch__portmod_port_interface_check_f)(int unit, int port, pm_info_t pm_info, const portmod_port_interface_config_t* config, int is_ext_phy, soc_port_if_t interface, int* is_valid);
typedef int (*__dispatch__portmod_port_encoding_set_f)(int unit, int port, pm_info_t pm_info, uint32 properties, portmod_port_pcs_t encoding);
typedef int (*__dispatch__portmod_port_encoding_get_f)(int unit, int port, pm_info_t pm_info, uint32* properties, portmod_port_pcs_t* encoding);
typedef int (*__dispatch__portmod_port_cl72_set_f)(int unit, int port, pm_info_t pm_info, uint32 enable);
typedef int (*__dispatch__portmod_port_cl72_get_f)(int unit, int port, pm_info_t pm_info, uint32* enable);
typedef int (*__dispatch__portmod_port_cl72_status_get_f)(int unit, int port, pm_info_t pm_info, phymod_cl72_status_t* status);
typedef int (*__dispatch__portmod_port_loopback_set_f)(int unit, int port, pm_info_t pm_info, portmod_loopback_mode_t loopback_type, int enable);
typedef int (*__dispatch__portmod_port_loopback_get_f)(int unit, int port, pm_info_t pm_info, portmod_loopback_mode_t loopback_type, int* enable);
typedef int (*__dispatch__portmod_port_pass_through_set_f)(int unit, int port, pm_info_t pm_info, int loopback_en, int enable);
typedef int (*__dispatch__portmod_port_pass_through_get_f)(int unit, int port, pm_info_t pm_info, int* loopback_en, int* enable);
typedef int (*__dispatch__portmod_port_pass_through_calibrate_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_pass_through_fec_enable_set_f)(int unit, int port, pm_info_t pm_info, int enable);
typedef int (*__dispatch__portmod_port_pass_through_fec_enable_get_f)(int unit, int port, pm_info_t pm_info, int* enable);
typedef int (*__dispatch__portmod_port_rx_mac_enable_set_f)(int unit, int port, pm_info_t pm_info, int enable);
typedef int (*__dispatch__portmod_port_rx_mac_enable_get_f)(int unit, int port, pm_info_t pm_info, int* enable);
typedef int (*__dispatch__portmod_port_tx_mac_enable_set_f)(int unit, int port, pm_info_t pm_info, int enable);
typedef int (*__dispatch__portmod_port_tx_mac_enable_get_f)(int unit, int port, pm_info_t pm_info, int* enable);
typedef int (*__dispatch__portmod_port_ability_local_get_f)(int unit, int port, pm_info_t pm_info, uint32 phy_flags, portmod_port_ability_t* ability);
typedef int (*__dispatch__portmod_port_autoneg_set_f)(int unit, int port, pm_info_t pm_info, uint32 phy_flags, const phymod_autoneg_control_t* an);
typedef int (*__dispatch__portmod_port_autoneg_get_f)(int unit, int port, pm_info_t pm_info, uint32 phy_flags, phymod_autoneg_control_t* an);
typedef int (*__dispatch__portmod_port_autoneg_status_get_f)(int unit, int port, pm_info_t pm_info, phymod_autoneg_status_t* an_status);
typedef int (*__dispatch__portmod_port_link_get_f)(int unit, int port, pm_info_t pm_info, int flags, int* link);
typedef int (*__dispatch__portmod_port_link_latch_down_get_f)(int unit, int port, pm_info_t pm_info, uint32 flags, int* link);
typedef int (*__dispatch__portmod_port_phy_link_up_event_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_phy_link_down_event_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_prbs_config_set_f)(int unit, int port, pm_info_t pm_info, portmod_prbs_mode_t mode, int flags, const phymod_prbs_t* config);
typedef int (*__dispatch__portmod_port_prbs_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_prbs_mode_t mode, int flags, phymod_prbs_t* config);
typedef int (*__dispatch__portmod_port_prbs_enable_set_f)(int unit, int port, pm_info_t pm_info, portmod_prbs_mode_t mode, int flags, int enable);
typedef int (*__dispatch__portmod_port_prbs_enable_get_f)(int unit, int port, pm_info_t pm_info, portmod_prbs_mode_t mode, int flags, int* enable);
typedef int (*__dispatch__portmod_port_prbs_status_get_f)(int unit, int port, pm_info_t pm_info, portmod_prbs_mode_t mode, int flags, phymod_prbs_status_t* status);
typedef int (*__dispatch__portmod_port_nof_lanes_get_f)(int unit, int port, pm_info_t pm_info, int* nof_lanes);
typedef int (*__dispatch__portmod_port_ilkn_nof_segments_set_f)(int unit, int port, pm_info_t pm_info, uint32 nof_segments);
typedef int (*__dispatch__portmod_port_ilkn_nof_segments_get_f)(int unit, int port, pm_info_t pm_info, uint32* nof_segments);
typedef int (*__dispatch__portmod_ilkn_retranstmit_config_set_f)(int unit, int port, pm_info_t pm_info, const ilkn_retransmit_config_t* retransmit_config);
typedef int (*__dispatch__portmod_ilkn_retranstmit_config_get_f)(int unit, int port, pm_info_t pm_info, ilkn_retransmit_config_t* retransmit_config);
typedef int (*__dispatch__portmod_port_lanes_assign_f)(int unit, int port, pm_info_t pm_info, const portmod_lanes_assign_info_t* assign_map);
typedef int (*__dispatch__portmod_port_lanes_retrieve_f)(int unit, int port, pm_info_t pm_info, portmod_lanes_assign_info_t* assign_map);
typedef int (*__dispatch__portmod_port_firmware_mode_set_f)(int unit, int port, pm_info_t pm_info, phymod_firmware_mode_t fw_mode);
typedef int (*__dispatch__portmod_port_firmware_mode_get_f)(int unit, int port, pm_info_t pm_info, phymod_firmware_mode_t* fw_mode);
typedef int (*__dispatch__portmod_port_runt_threshold_set_f)(int unit, int port, pm_info_t pm_info, int value);
typedef int (*__dispatch__portmod_port_runt_threshold_get_f)(int unit, int port, pm_info_t pm_info, int* value);
typedef int (*__dispatch__portmod_port_max_packet_size_set_f)(int unit, int port, pm_info_t pm_info, int value);
typedef int (*__dispatch__portmod_port_max_packet_size_get_f)(int unit, int port, pm_info_t pm_info, int* value);
typedef int (*__dispatch__portmod_port_pad_size_set_f)(int unit, int port, pm_info_t pm_info, int value);
typedef int (*__dispatch__portmod_port_pad_size_get_f)(int unit, int port, pm_info_t pm_info, int* value);
typedef int (*__dispatch__portmod_port_tx_mac_sa_set_f)(int unit, int port, pm_info_t pm_info, sal_mac_addr_t mac_sa);
typedef int (*__dispatch__portmod_port_tx_mac_sa_get_f)(int unit, int port, pm_info_t pm_info, sal_mac_addr_t mac_sa);
typedef int (*__dispatch__portmod_port_rx_mac_sa_set_f)(int unit, int port, pm_info_t pm_info, sal_mac_addr_t mac_sa);
typedef int (*__dispatch__portmod_port_rx_mac_sa_get_f)(int unit, int port, pm_info_t pm_info, sal_mac_addr_t mac_sa);
typedef int (*__dispatch__portmod_port_tx_average_ipg_set_f)(int unit, int port, pm_info_t pm_info, int value);
typedef int (*__dispatch__portmod_port_tx_average_ipg_get_f)(int unit, int port, pm_info_t pm_info, int* value);
typedef int (*__dispatch__portmod_port_tx_preamble_length_set_f)(int unit, int port, pm_info_t pm_info, int value);
typedef int (*__dispatch__portmod_port_tx_preamble_length_get_f)(int unit, int port, pm_info_t pm_info, int* value);
typedef int (*__dispatch__portmod_port_local_fault_control_set_f)(int unit, int port, pm_info_t pm_info, const portmod_local_fault_control_t* control);
typedef int (*__dispatch__portmod_port_local_fault_control_get_f)(int unit, int port, pm_info_t pm_info, portmod_local_fault_control_t* control);
typedef int (*__dispatch__portmod_port_remote_fault_control_set_f)(int unit, int port, pm_info_t pm_info, const portmod_remote_fault_control_t* control);
typedef int (*__dispatch__portmod_port_remote_fault_control_get_f)(int unit, int port, pm_info_t pm_info, portmod_remote_fault_control_t* control);
typedef int (*__dispatch__portmod_port_local_fault_status_get_f)(int unit, int port, pm_info_t pm_info, int* value);
typedef int (*__dispatch__portmod_port_remote_fault_status_get_f)(int unit, int port, pm_info_t pm_info, int* value);
typedef int (*__dispatch__portmod_port_local_fault_status_clear_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_remote_fault_status_clear_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_pause_control_set_f)(int unit, int port, pm_info_t pm_info, const portmod_pause_control_t* control);
typedef int (*__dispatch__portmod_port_pause_control_get_f)(int unit, int port, pm_info_t pm_info, portmod_pause_control_t* control);
typedef int (*__dispatch__portmod_port_pfc_control_set_f)(int unit, int port, pm_info_t pm_info, const portmod_pfc_control_t* control);
typedef int (*__dispatch__portmod_port_pfc_control_get_f)(int unit, int port, pm_info_t pm_info, portmod_pfc_control_t* control);
typedef int (*__dispatch__portmod_port_llfc_control_set_f)(int unit, int port, pm_info_t pm_info, const portmod_llfc_control_t* control);
typedef int (*__dispatch__portmod_port_llfc_control_get_f)(int unit, int port, pm_info_t pm_info, portmod_llfc_control_t* control);
typedef int (*__dispatch__portmod_port_update_f)(int unit, int port, pm_info_t pm_info, const portmod_port_update_control_t* update_control);
typedef int (*__dispatch__portmod_port_core_access_get_f)(int unit, int port, pm_info_t pm_info, int phyn, int max_cores, phymod_core_access_t* core_access_arr, int* nof_cores, int* is_most_ext);
typedef int (*__dispatch__portmod_port_phy_lane_access_get_f)(int unit, int port, pm_info_t pm_info, const portmod_access_get_params_t* params, int max_phys, phymod_phy_access_t* access, int* nof_phys, int* is_most_ext);
typedef int (*__dispatch__portmod_pm_phy_lane_access_get_f)(int unit, int pm_id, pm_info_t pm_info, const portmod_access_get_params_t* params, int max_phys, phymod_phy_access_t* access, int* nof_phys, int* is_most_ext);
typedef int (*__dispatch__portmod_port_duplex_set_f)(int unit, int port, pm_info_t pm_info, int enable);
typedef int (*__dispatch__portmod_port_duplex_get_f)(int unit, int port, pm_info_t pm_info, int* enable);
typedef int (*__dispatch__portmod_port_phy_reg_read_f)(int unit, int port, pm_info_t pm_info, int lane, int flags, int reg_addr, uint32* value);
typedef int (*__dispatch__portmod_port_phy_reg_write_f)(int unit, int port, pm_info_t pm_info, int lane, int flags, int reg_addr, uint32 value);
typedef int (*__dispatch__portmod_port_reset_set_f)(int unit, int port, pm_info_t pm_info, int mode, int opcode, int value);
typedef int (*__dispatch__portmod_port_reset_get_f)(int unit, int port, pm_info_t pm_info, int mode, int opcode, int* value);
typedef int (*__dispatch__portmod_port_adv_remote_get_f)(int unit, int port, pm_info_t pm_info, int* value);
typedef int (*__dispatch__portmod_port_drv_name_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_drv_name_get_f)(int unit, int port, pm_info_t pm_info, char* name, int len);
typedef int (*__dispatch__portmod_port_fec_enable_set_f)(int unit, int port, pm_info_t pm_info, uint32 phy_flags, uint32_t enable);
typedef int (*__dispatch__portmod_port_fec_enable_get_f)(int unit, int port, pm_info_t pm_info, uint32 phy_flags, uint32_t* enable);
typedef int (*__dispatch__portmod_port_ability_advert_set_f)(int unit, int port, pm_info_t pm_info, uint32 phy_flags, portmod_port_ability_t* ability);
typedef int (*__dispatch__portmod_port_ability_advert_get_f)(int unit, int port, pm_info_t pm_info, uint32 phy_flags, portmod_port_ability_t* ability);
typedef int (*__dispatch__portmod_port_ability_remote_get_f)(int unit, int port, pm_info_t pm_info, uint32 phy_flags, portmod_port_ability_t* ability);
typedef int (*__dispatch__portmod_port_frame_spacing_stretch_set_f)(int unit, int port, pm_info_t pm_info, int spacing);
typedef int (*__dispatch__portmod_port_frame_spacing_stretch_get_f)(int unit, int port, pm_info_t pm_info, const int* spacing);
typedef int (*__dispatch__portmod_port_diag_fifo_status_get_f)(int unit, int port, pm_info_t pm_info, const portmod_fifo_status_t* diag_info);
typedef int (*__dispatch__portmod_port_rx_control_set_f)(int unit, int port, pm_info_t pm_info, const portmod_rx_control_t* rx_ctrl);
typedef int (*__dispatch__portmod_port_rx_control_get_f)(int unit, int port, pm_info_t pm_info, portmod_rx_control_t* rx_ctrl);
typedef int (*__dispatch__portmod_port_pfc_config_set_f)(int unit, int port, pm_info_t pm_info, const portmod_pfc_config_t* pfc_cfg);
typedef int (*__dispatch__portmod_port_pfc_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_pfc_config_t* pfc_cfg);
typedef int (*__dispatch__portmod_port_eee_set_f)(int unit, int port, pm_info_t pm_info, const portmod_eee_t* eee);
typedef int (*__dispatch__portmod_port_eee_get_f)(int unit, int port, pm_info_t pm_info, portmod_eee_t* eee);
typedef int (*__dispatch__portmod_port_eee_clock_set_f)(int unit, int port, pm_info_t pm_info, const portmod_eee_clock_t* eee_clk);
typedef int (*__dispatch__portmod_port_eee_clock_get_f)(int unit, int port, pm_info_t pm_info, portmod_eee_clock_t* eee_clk);
typedef int (*__dispatch__portmod_port_vlan_tag_set_f)(int unit, int port, pm_info_t pm_info, const portmod_vlan_tag_t* vlan_tag);
typedef int (*__dispatch__portmod_port_vlan_tag_get_f)(int unit, int port, pm_info_t pm_info, portmod_vlan_tag_t* vlan_tag);
typedef int (*__dispatch__portmod_port_modid_set_f)(int unit, int port, pm_info_t pm_info, int value);
typedef int (*__dispatch__portmod_port_led_chain_config_f)(int unit, int port, pm_info_t pm_info, int value);
typedef int (*__dispatch__portmod_port_clear_rx_lss_status_set_f)(int unit, int port, pm_info_t pm_info, int lcl_fault, int rmt_fault);
typedef int (*__dispatch__portmod_port_clear_rx_lss_status_get_f)(int unit, int port, pm_info_t pm_info, int* lcl_fault, int* rmt_fault);
typedef int (*__dispatch__portmod_xphy_lane_attach_to_pm_f)(int unit, pm_info_t pm_info, int iphy, int phyn, const portmod_xphy_lane_connection_t* lane_connection);
typedef int (*__dispatch__portmod_xphy_lane_detach_from_pm_f)(int unit, pm_info_t pm_info, int iphy, int phyn, portmod_xphy_lane_connection_t* lane_connection);
typedef int (*__dispatch__portmod_ext_phy_lane_attach_to_pm_f)(int unit, pm_info_t pm_info, int iphy, int phyn, const portmod_lane_connection_t* lane_connection);
typedef int (*__dispatch__portmod_ext_phy_lane_detach_from_pm_f)(int unit, pm_info_t pm_info, int iphy, int phyn, portmod_lane_connection_t* lane_connection);
typedef int (*__dispatch__portmod_port_lag_failover_status_toggle_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_lag_failover_loopback_set_f)(int unit, int port, pm_info_t pm_info, int value);
typedef int (*__dispatch__portmod_port_lag_failover_loopback_get_f)(int unit, int port, pm_info_t pm_info, int* value);
typedef int (*__dispatch__portmod_port_mode_set_f)(int unit, int port, pm_info_t pm_info, const portmod_port_mode_info_t* mode);
typedef int (*__dispatch__portmod_port_mode_get_f)(int unit, int port, pm_info_t pm_info, portmod_port_mode_info_t* mode);
typedef int (*__dispatch__portmod_port_encap_set_f)(int unit, int port, pm_info_t pm_info, int flags, portmod_encap_t encap);
typedef int (*__dispatch__portmod_port_encap_get_f)(int unit, int port, pm_info_t pm_info, int* flags, portmod_encap_t* encap);
typedef int (*__dispatch__portmod_port_higig_mode_set_f)(int unit, int port, pm_info_t pm_info, int mode);
typedef int (*__dispatch__portmod_port_higig_mode_get_f)(int unit, int port, pm_info_t pm_info, int* mode);
typedef int (*__dispatch__portmod_port_higig2_mode_set_f)(int unit, int port, pm_info_t pm_info, int mode);
typedef int (*__dispatch__portmod_port_higig2_mode_get_f)(int unit, int port, pm_info_t pm_info, int* mode);
typedef int (*__dispatch__portmod_port_config_port_type_set_f)(int unit, int port, pm_info_t pm_info, int type);
typedef int (*__dispatch__portmod_port_config_port_type_get_f)(int unit, int port, pm_info_t pm_info, int* type);
typedef int (*__dispatch__portmod_port_trunk_hwfailover_config_set_f)(int unit, int port, pm_info_t pm_info, int hw_count);
typedef int (*__dispatch__portmod_port_trunk_hwfailover_config_get_f)(int unit, int port, pm_info_t pm_info, int* enable);
typedef int (*__dispatch__portmod_port_trunk_hwfailover_status_get_f)(int unit, int port, pm_info_t pm_info, int* loopback);
typedef int (*__dispatch__portmod_port_diag_ctrl_f)(int unit, int port, pm_info_t pm_info, uint32 inst, int op_type, int op_cmd, const void* arg);
typedef int (*__dispatch__portmod_port_ref_clk_get_f)(int unit, int port, pm_info_t pm_info, int* ref_clk);
typedef int (*__dispatch__portmod_port_lag_failover_disable_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_lag_remove_failover_lpbk_set_f)(int unit, int port, pm_info_t pm_info, int val);
typedef int (*__dispatch__portmod_port_lag_remove_failover_lpbk_get_f)(int unit, int port, pm_info_t pm_info, int* val);
typedef int (*__dispatch__portmod_port_cntmaxsize_set_f)(int unit, int port, pm_info_t pm_info, int val);
typedef int (*__dispatch__portmod_port_cntmaxsize_get_f)(int unit, int port, pm_info_t pm_info, int* val);
typedef int (*__dispatch__portmod_port_multi_get_f)(int unit, int port, pm_info_t pm_info, portmod_multi_get_t* multi_get);
typedef int (*__dispatch__portmod_port_drain_cell_get_f)(int unit, int port, pm_info_t pm_info, portmod_drain_cells_t* drain_cells);
typedef int (*__dispatch__portmod_port_drain_cell_stop_f)(int unit, int port, pm_info_t pm_info, const portmod_drain_cells_t* drain_cells);
typedef int (*__dispatch__portmod_port_drain_cell_start_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_drain_cells_rx_enable_f)(int unit, int port, pm_info_t pm_info, int rx_en);
typedef int (*__dispatch__portmod_port_egress_queue_drain_rx_en_f)(int unit, int port, pm_info_t pm_info, int rx_en);
typedef int (*__dispatch__portmod_port_mac_ctrl_set_f)(int unit, int port, pm_info_t pm_info, uint64 ctrl);
typedef int (*__dispatch__portmod_port_txfifo_cell_cnt_get_f)(int unit, int port, pm_info_t pm_info, uint32* cnt);
typedef int (*__dispatch__portmod_port_egress_queue_drain_get_f)(int unit, int port, pm_info_t pm_info, uint64* ctrl, int* rxen);
typedef int (*__dispatch__portmod_port_mac_reset_set_f)(int unit, int port, pm_info_t pm_info, int val);
typedef int (*__dispatch__portmod_port_mac_reset_get_f)(int unit, int port, pm_info_t pm_info, int* val);
typedef int (*__dispatch__portmod_port_soft_reset_toggle_f)(int unit, int port, pm_info_t pm_info, int idx);
typedef int (*__dispatch__portmod_port_mac_reset_check_f)(int unit, int port, pm_info_t pm_info, int enable, int* reset);
typedef int (*__dispatch__portmod_port_core_num_get_f)(int unit, int port, pm_info_t pm_info, int* core_num);
typedef int (*__dispatch__portmod_port_e2ecc_hdr_set_f)(int unit, int port, pm_info_t pm_info, const portmod_port_higig_e2ecc_hdr_t* e2ecc_hdr);
typedef int (*__dispatch__portmod_port_e2ecc_hdr_get_f)(int unit, int port, pm_info_t pm_info, portmod_port_higig_e2ecc_hdr_t* e2ecc_hdr);
typedef int (*__dispatch__portmod_port_e2e_enable_set_f)(int unit, int port, pm_info_t pm_info, int enable);
typedef int (*__dispatch__portmod_port_e2e_enable_get_f)(int unit, int port, pm_info_t pm_info, int* enable);
typedef int (*__dispatch__portmod_port_fallback_lane_get_f)(int unit, int port, pm_info_t pm_info, int* fallback_lane);
typedef int (*__dispatch__portmod_port_speed_get_f)(int unit, int port, pm_info_t pm_info, int* speed);
typedef int (*__dispatch__portmod_port_tsc_refclock_set_f)(int unit, int port, pm_info_t pm_info, int ref_in, int ref_out);
typedef int (*__dispatch__portmod_port_tsc_refclock_get_f)(int unit, int port, pm_info_t pm_info, int* ref_in, int* ref_out);
typedef int (*__dispatch__portmod_port_discard_set_f)(int unit, int port, pm_info_t pm_info, int discard);
typedef int (*__dispatch__portmod_port_soft_reset_set_f)(int unit, int port, pm_info_t pm_info, int idx, int val, int flags);
typedef int (*__dispatch__portmod_port_tx_down_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_logical_lane_order_set_f)(int unit, int port, pm_info_t pm_info, const int* lane_order, int lane_order_size);
typedef int (*__dispatch__portmod_port_logical_lane_order_get_f)(int unit, int port, pm_info_t pm_info, int lane_order_max_size, int* lane_order, int* lane_order_actual_size);
typedef int (*__dispatch__portmod_port_pgw_reconfig_f)(int unit, int port, pm_info_t pm_info, const portmod_port_mode_info_t* pmode, int phy_port, int flags);
typedef int (*__dispatch__portmod_port_notify_f)(int unit, int port, pm_info_t pm_info, int link);
typedef int (*__dispatch__portmod_port_control_phy_timesync_set_f)(int unit, int port, pm_info_t pm_info, portmod_port_control_phy_timesync_t config, uint64 value);
typedef int (*__dispatch__portmod_port_control_phy_timesync_get_f)(int unit, int port, pm_info_t pm_info, portmod_port_control_phy_timesync_t config, uint64* value);
typedef int (*__dispatch__portmod_port_timesync_config_set_f)(int unit, int port, pm_info_t pm_info, const portmod_phy_timesync_config_t* config);
typedef int (*__dispatch__portmod_port_timesync_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_phy_timesync_config_t* config);
typedef int (*__dispatch__portmod_port_timesync_enable_set_f)(int unit, int port, pm_info_t pm_info, uint32 enable);
typedef int (*__dispatch__portmod_port_timesync_enable_get_f)(int unit, int port, pm_info_t pm_info, uint32* enable);
typedef int (*__dispatch__portmod_port_timesync_nco_addend_set_f)(int unit, int port, pm_info_t pm_info, uint32 freq_step);
typedef int (*__dispatch__portmod_port_timesync_nco_addend_get_f)(int unit, int port, pm_info_t pm_info, uint32* freq_step);
typedef int (*__dispatch__portmod_port_timesync_framesync_mode_set_f)(int unit, int port, pm_info_t pm_info, const portmod_timesync_framesync_t* framesync);
typedef int (*__dispatch__portmod_port_timesync_framesync_mode_get_f)(int unit, int port, pm_info_t pm_info, portmod_timesync_framesync_t* framesync);
typedef int (*__dispatch__portmod_port_timesync_local_time_set_f)(int unit, int port, pm_info_t pm_info, uint64 local_time);
typedef int (*__dispatch__portmod_port_timesync_local_time_get_f)(int unit, int port, pm_info_t pm_info, uint64* local_time);
typedef int (*__dispatch__portmod_port_timesync_load_ctrl_set_f)(int unit, int port, pm_info_t pm_info, uint32 load_once, uint32 load_always);
typedef int (*__dispatch__portmod_port_timesync_load_ctrl_get_f)(int unit, int port, pm_info_t pm_info, uint32* load_once, uint32* load_always);
typedef int (*__dispatch__portmod_port_timesync_tx_timestamp_offset_set_f)(int unit, int port, pm_info_t pm_info, uint32 ts_offset);
typedef int (*__dispatch__portmod_port_timesync_tx_timestamp_offset_get_f)(int unit, int port, pm_info_t pm_info, uint32* ts_offset);
typedef int (*__dispatch__portmod_port_timesync_rx_timestamp_offset_set_f)(int unit, int port, pm_info_t pm_info, uint32 ts_offset);
typedef int (*__dispatch__portmod_port_timesync_rx_timestamp_offset_get_f)(int unit, int port, pm_info_t pm_info, uint32* ts_offset);
typedef int (*__dispatch__portmod_port_timestamp_adjust_set_f)(int unit, int port, pm_info_t pm_info, const soc_port_timestamp_adjust_t* ts_adjust);
typedef int (*__dispatch__portmod_port_timestamp_adjust_get_f)(int unit, int port, pm_info_t pm_info, soc_port_timestamp_adjust_t* ts_adjust);
typedef int (*__dispatch__portmod_port_phy_intr_enable_set_f)(int unit, int port, pm_info_t pm_info, uint32 intr_enable);
typedef int (*__dispatch__portmod_port_phy_intr_enable_get_f)(int unit, int port, pm_info_t pm_info, uint32* intr_enable);
typedef int (*__dispatch__portmod_port_phy_intr_status_get_f)(int unit, int port, pm_info_t pm_info, uint32* intr_status);
typedef int (*__dispatch__portmod_port_phy_intr_status_clear_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_phy_timesync_do_sync_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_timesync_capture_timestamp_get_f)(int unit, int port, pm_info_t pm_info, uint64* cap_ts);
typedef int (*__dispatch__portmod_port_timesync_heartbeat_timestamp_get_f)(int unit, int port, pm_info_t pm_info, uint64* hb_ts);
typedef int (*__dispatch__portmod_port_edc_config_set_f)(int unit, int port, pm_info_t pm_info, const portmod_edc_config_t* config);
typedef int (*__dispatch__portmod_port_edc_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_edc_config_t* config);
typedef int (*__dispatch__portmod_port_interrupt_enable_set_f)(int unit, int port, pm_info_t pm_info, int intr_type, uint32 val);
typedef int (*__dispatch__portmod_port_interrupt_enable_get_f)(int unit, int port, pm_info_t pm_info, int intr_type, uint32* val);
typedef int (*__dispatch__portmod_port_interrupt_get_f)(int unit, int port, pm_info_t pm_info, int intr_type, uint32* val);
typedef int (*__dispatch__portmod_port_interrupts_get_f)(int unit, int port, pm_info_t pm_info, int arr_max_size, uint32* intr_arr, uint32* size);
typedef int (*__dispatch__portmod_port_check_legacy_phy_f)(int unit, int port, pm_info_t pm_info, int* legacy_phy);
typedef int (*__dispatch__portmod_port_failover_mode_set_f)(int unit, int port, pm_info_t pm_info, phymod_failover_mode_t failover);
typedef int (*__dispatch__portmod_port_failover_mode_get_f)(int unit, int port, pm_info_t pm_info, phymod_failover_mode_t* failover);
typedef int (*__dispatch__portmod_port_mac_rsv_mask_set_f)(int unit, int port, pm_info_t pm_info, uint32 rsv_mask);
typedef int (*__dispatch__portmod_port_mib_reset_toggle_f)(int unit, int port, pm_info_t pm_info, int port_index);
typedef int (*__dispatch__portmod_port_warmboot_db_restore_f)(int unit, int port, pm_info_t pm_info, const portmod_port_interface_config_t* intf_config, const portmod_port_init_config_t* init_config, phymod_operation_mode_t phy_op_mode);
typedef int (*__dispatch__portmod_port_flow_control_set_f)(int unit, int port, pm_info_t pm_info, int merge_mode_en, int parallel_fc_en);
typedef int (*__dispatch__portmod_port_update_dynamic_state_f)(int unit, int port, pm_info_t pm_info, uint32_t port_dynamic_state);
typedef int (*__dispatch__portmod_port_phy_op_mode_get_f)(int unit, int port, pm_info_t pm_info, phymod_operation_mode_t* val);
typedef int (*__dispatch__portmod_port_lane_map_set_f)(int unit, int port, pm_info_t pm_info, uint32 flags, const phymod_lane_map_t* lane_map);
typedef int (*__dispatch__portmod_port_lane_map_get_f)(int unit, int port, pm_info_t pm_info, uint32 flags, phymod_lane_map_t* lane_map);
typedef int (*__dispatch__portmod_port_polarity_set_f)(int unit, int port, pm_info_t pm_info, const phymod_polarity_t* polarity);
typedef int (*__dispatch__portmod_port_polarity_get_f)(int unit, int port, pm_info_t pm_info, phymod_polarity_t* polarity);
typedef int (*__dispatch__portmod_port_medium_config_set_f)(int unit, int port, pm_info_t pm_info, soc_port_medium_t medium, soc_phy_config_t* config);
typedef int (*__dispatch__portmod_port_medium_config_get_f)(int unit, int port, pm_info_t pm_info, soc_port_medium_t medium, soc_phy_config_t* config);
typedef int (*__dispatch__portmod_port_medium_get_f)(int unit, int port, pm_info_t pm_info, soc_port_medium_t* medium);
typedef int (*__dispatch__portmod_pm_is_in_pm12x10_f)(int unit, pm_info_t pm_info, int* in_pm12x10);
typedef int (*__dispatch__portmod_slow_read_rate_set_f)(int unit, int port, pm_info_t pm_info, int slow_read_rate);
typedef int (*__dispatch__portmod_port_pll_div_get_f)(int unit, int port, pm_info_t pm_info, const portmod_port_resources_t* port_resource, uint32_t* pll_div);
typedef int (*__dispatch__portmod_port_master_set_f)(int unit, int port, pm_info_t pm_info, int master_mode);
typedef int (*__dispatch__portmod_port_master_get_f)(int unit, int port, pm_info_t pm_info, int* master_mode);
typedef int (*__dispatch__portmod_preemption_control_set_f)(int unit, int port, pm_info_t pm_info, portmod_preemption_control_t type, uint32 value);
typedef int (*__dispatch__portmod_preemption_control_get_f)(int unit, int port, pm_info_t pm_info, portmod_preemption_control_t type, uint32* value);
typedef int (*__dispatch__portmod_preemption_tx_status_get_f)(int unit, int port, pm_info_t pm_info, uint32* value);
typedef int (*__dispatch__portmod_preemption_verify_status_get_f)(int unit, int port, pm_info_t pm_info, portmod_preemption_verify_status_type_t type, uint32* value);
typedef int (*__dispatch__portmod_preemption_force_rx_eop_mode_set_f)(int unit, int port, pm_info_t pm_info, portmod_preemption_force_rx_eop_mode_t type, uint32 value);
typedef int (*__dispatch__portmod_preemption_force_rx_eop_mode_get_f)(int unit, int port, pm_info_t pm_info, portmod_preemption_force_rx_eop_mode_t type, uint32* value);
typedef int (*__dispatch__portmod_preemption_rx_timeout_set_f)(int unit, int port, pm_info_t pm_info, uint32 enable, uint32 timeout_cnt);
typedef int (*__dispatch__portmod_preemption_rx_timeout_get_f)(int unit, int port, pm_info_t pm_info, uint32* enable, uint32* timeout_cnt);
typedef int (*__dispatch__portmod_port_lane_count_get_f)(int unit, int port, pm_info_t pm_info, int line_side, int* num_lanes);
typedef int (*__dispatch__portmod_port_timesync_tx_info_get_f)(int unit, int port, pm_info_t pm_info, portmod_fifo_status_t* tx_info);
typedef int (*__dispatch__portmod_port_lane_mask_get_f)(int unit, int port, pm_info_t pm_info, const portmod_access_get_params_t* params, int* lane_mask, int* xphy_id);
typedef int (*__dispatch__portmod_core_add_f)(int unit, int pm_id, pm_info_t pm_info, const portmod_port_add_info_t* add_info);
typedef int (*__dispatch__portmod_pm_serdes_core_init_f)(int unit, int pm_id, pm_info_t pm_info, const portmod_port_add_info_t* add_info);
typedef int (*__dispatch__portmod_pm_is_initialized_f)(int unit, int pm_id, pm_info_t pm_info, int* is_initialized);
typedef int (*__dispatch__portmod_port_speed_config_validate_f)(int unit, int port, pm_info_t pm_info, const portmod_speed_config_t* speed_config, portmod_pbmp_t* affected_pbmp);
typedef int (*__dispatch__portmod_pm_enable_f)(int unit, int pm_id, pm_info_t pm_info, int enable);
typedef int (*__dispatch__portmod_pm_logical_pbmp_get_f)(int unit, int pm_id, pm_info_t pm_info, portmod_pbmp_t* logical_pbmp);
typedef int (*__dispatch__portmod_pm_vco_reconfig_f)(int unit, int pm_id, pm_info_t pm_info, const portmod_vco_type_t* vco);
typedef int (*__dispatch__portmod_port_speed_config_set_f)(int unit, int port, pm_info_t pm_info, const portmod_speed_config_t* speed_config);
typedef int (*__dispatch__portmod_port_speed_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_speed_config_t* speed_config);
typedef int (*__dispatch__portmod_fw_bcast_f)(int unit, pm_info_t pm_info, const portmod_sbus_bcast_config_t* sbus_bcast_cfg);
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_stage_activate_f)(int unit, int port, pm_info_t pm_info, portmod_cpri_stage_t stage);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rsvd4_tx_fsm_state_set_f)(int unit, int port, pm_info_t pm_info, cprimod_rsvd4_tx_fsm_state_t state);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rsvd4_tx_override_set_f)(int unit, int port, pm_info_t pm_info, cprimod_rsvd4_tx_overide_t parameter, int enable, int value);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rsvd4_rx_override_set_f)(int unit, int port, pm_info_t pm_info, cprimod_rsvd4_rx_overide_t parameter, int enable, int value);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_axc_frame_add_f)(int unit, int port, pm_info_t pm_info, uint32 axc_id, const portmod_cpri_axc_frame_info_t* frame_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_frame_optional_config_set_f)(int unit, int port, pm_info_t pm_info, cprimod_rx_config_field_t field, int value);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_frame_optional_config_get_f)(int unit, int port, pm_info_t pm_info, cprimod_rx_config_field_t field, int* value);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_frame_optional_config_set_f)(int unit, int port, pm_info_t pm_info, cprimod_tx_config_field_t field, uint32 value);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_frame_optional_config_get_f)(int unit, int port, pm_info_t pm_info, cprimod_tx_config_field_t field, uint32* value);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_port_rsvd4_rx_frame_optional_config_set_f)(int unit, int port, pm_info_t pm_info, cprimod_rsvd4_rx_config_field_t field, int value);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_port_rsvd4_rx_frame_optional_config_get_f)(int unit, int port, pm_info_t pm_info, cprimod_rsvd4_rx_config_field_t field, int* value);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_port_rsvd4_tx_frame_optional_config_set_f)(int unit, int port, pm_info_t pm_info, cprimod_rsvd4_tx_config_field_t field, int value);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_port_rsvd4_tx_frame_optional_config_get_f)(int unit, int port, pm_info_t pm_info, cprimod_rsvd4_tx_config_field_t field, int* value);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_port_rsvd4_rx_speed_set_f)(int unit, int port, pm_info_t pm_info, cprimod_port_rsvd4_speed_mult_t speed);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_port_rsvd4_rx_speed_get_f)(int unit, int port, pm_info_t pm_info, cprimod_port_rsvd4_speed_mult_t* speed);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_port_rsvd4_tx_speed_set_f)(int unit, int port, pm_info_t pm_info, cprimod_port_rsvd4_speed_mult_t speed);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_port_rsvd4_tx_speed_get_f)(int unit, int port, pm_info_t pm_info, cprimod_port_rsvd4_speed_mult_t* speed);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_axc_frame_delete_f)(int unit, int port, pm_info_t pm_info, uint32 axc_id);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_axc_frame_get_f)(int unit, int port, pm_info_t pm_info, uint32 axc_id, portmod_cpri_axc_frame_info_t* frame_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rsvd4_rx_fsm_state_set_f)(int unit, int port, pm_info_t pm_info, cprimod_rsvd4_rx_fsm_state_t state);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_axc_frame_add_f)(int unit, int port, pm_info_t pm_info, uint32 axc_id, const portmod_cpri_axc_frame_info_t* frame_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_axc_frame_delete_f)(int unit, int port, pm_info_t pm_info, uint32 axc_id);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_axc_frame_get_f)(int unit, int port, pm_info_t pm_info, uint32 axc_id, portmod_cpri_axc_frame_info_t* frame_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_encap_set_f)(int unit, int port, pm_info_t pm_info, uint32 queue_num, const cprimod_encap_header_config_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_encap_get_f)(int unit, int port, pm_info_t pm_info, uint32 queue_num, cprimod_encap_header_config_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_encap_roe_ordering_info_set_f)(int unit, int port, pm_info_t pm_info, uint32 index, const cprimod_encap_ordering_info_entry_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_encap_roe_ordering_info_get_f)(int unit, int port, pm_info_t pm_info, uint32 index, cprimod_encap_ordering_info_entry_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_encap_roe_ordering_sequence_offset_set_f)(int unit, int port, pm_info_t pm_info, uint32 queue_num, uint32 control, const cprimod_cpri_ordering_info_offset_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_encap_roe_ordering_sequence_offset_get_f)(int unit, int port, pm_info_t pm_info, uint32 queue_num, uint32 control, cprimod_cpri_ordering_info_offset_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_roe_encap_macda_entry_set_f)(int unit, int port, pm_info_t pm_info, uint32 index, cprimod_mac_addr_t mac_addr);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_roe_encap_macda_entry_get_f)(int unit, int port, pm_info_t pm_info, uint32 index, cprimod_mac_addr_t mac_addr);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_roe_encap_macsa_entry_set_f)(int unit, int port, pm_info_t pm_info, uint32 index, cprimod_mac_addr_t mac_addr);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_roe_encap_macsa_entry_get_f)(int unit, int port, pm_info_t pm_info, uint32 index, cprimod_mac_addr_t mac_addr);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_roe_encap_vlan_entry_set_f)(int unit, int port, pm_info_t pm_info, uint32 index, cprimod_vlan_table_id_t table_id, uint32 vlan_id);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_roe_encap_vlan_entry_get_f)(int unit, int port, pm_info_t pm_info, uint32 index, cprimod_vlan_table_id_t table_id, uint32* vlan_id);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_decap_ethertype_config_set_f)(int unit, int port, pm_info_t pm_info, cprimod_ethertype_t pkt_type, uint16 ethtype);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_decap_ethertype_config_get_f)(int unit, int port, pm_info_t pm_info, cprimod_ethertype_t pkt_type, uint16* ethtype);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_encap_ethertype_config_set_f)(int unit, int port, pm_info_t pm_info, cprimod_ethertype_t pkt_type, uint16 ethtype);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_encap_ethertype_config_get_f)(int unit, int port, pm_info_t pm_info, cprimod_ethertype_t pkt_type, uint16* ethtype);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_decap_flow_config_set_f)(int unit, int port, pm_info_t pm_info, uint8 roe_subtype, uint32 queue_num, cprimod_cls_option_t cls_option, cprimod_cls_flow_type_t flow_type);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_decap_flow_config_get_f)(int unit, int port, pm_info_t pm_info, uint8 roe_subtype, uint32* queue_num, cprimod_cls_option_t* cls_option, cprimod_cls_flow_type_t* flow_type);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_decap_queue_to_ordering_info_index_set_f)(int unit, int port, pm_info_t pm_info, uint32 queue_num, uint32 ordering_info_index);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_decap_queue_to_ordering_info_index_get_f)(int unit, int port, pm_info_t pm_info, uint32 queue_num, uint32* ordering_info_index);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_decap_flow_to_queue_mapping_set_f)(int unit, int port, pm_info_t pm_info, uint32 flow_id, uint32 queue_num);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_decap_flow_to_queue_mapping_get_f)(int unit, int port, pm_info_t pm_info, uint32 flow_id, uint32* queue_num);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_decap_roe_ordering_info_set_f)(int unit, int port, pm_info_t pm_info, uint32 index, const cprimod_decap_ordering_info_entry_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_decap_roe_ordering_info_get_f)(int unit, int port, pm_info_t pm_info, uint32 index, cprimod_decap_ordering_info_entry_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_decap_roe_ordering_sequence_offset_set_f)(int unit, int port, pm_info_t pm_info, uint32 queue_num, const cprimod_cpri_ordering_info_offset_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_decap_roe_ordering_sequence_offset_get_f)(int unit, int port, pm_info_t pm_info, uint32 queue_num, cprimod_cpri_ordering_info_offset_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_frame_tgen_config_set_f)(int unit, int port, pm_info_t pm_info, const portmod_tx_frame_tgen_config_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_frame_tgen_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_tx_frame_tgen_config_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_frame_tgen_enable_f)(int unit, int port, pm_info_t pm_info, uint32 enable);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_frame_tgen_ts_offset_set_f)(int unit, int port, pm_info_t pm_info, uint64 offset);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_frame_tgen_ts_offset_get_f)(int unit, int port, pm_info_t pm_info, uint64* offset);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_frame_tgen_next_hfn_set_f)(int unit, int port, pm_info_t pm_info, uint32 hfn);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_frame_tgen_next_hfn_get_f)(int unit, int port, pm_info_t pm_info, uint32* hfn);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_frame_tgen_next_bfn_set_f)(int unit, int port, pm_info_t pm_info, uint32 bfn);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_frame_tgen_next_bfn_get_f)(int unit, int port, pm_info_t pm_info, uint32* bfn);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rsvd4_rx_flow_add_f)(int unit, int port, pm_info_t pm_info, uint32 flow_id, const portmod_rsvd4_rx_flow_info_t* info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rsvd4_rx_flow_delete_f)(int unit, int port, pm_info_t pm_info, uint32 flow_id);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rsvd4_tx_flow_add_f)(int unit, int port, pm_info_t pm_info, uint32 flow_id, const portmod_rsvd4_tx_flow_info_t* info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rsvd4_tx_flow_delete_f)(int unit, int port, pm_info_t pm_info, uint32 flow_id);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rsvd4_dbm_entry_set_f)(int unit, int port, pm_info_t pm_info, uint32 profile_id, const cprimod_dbm_rule_entry_t* profile);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rsvd4_dbm_entry_get_f)(int unit, int port, pm_info_t pm_info, uint32 profile_id, cprimod_dbm_rule_entry_t* profile);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rsvd4_secondary_dbm_entry_set_f)(int unit, int port, pm_info_t pm_info, uint32 profile_id, const cprimod_secondary_dbm_rule_entry_t* profile);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rsvd4_secondary_dbm_entry_get_f)(int unit, int port, pm_info_t pm_info, uint32 profile_id, cprimod_secondary_dbm_rule_entry_t* profile);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rsvd4_modulo_rule_entry_set_f)(int unit, int port, pm_info_t pm_info, uint32 modulo_rule_num, cprimod_transmission_rule_type_t modulo_rule_type, const cprimod_modulo_rule_entry_t* modulo_rule);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rsvd4_modulo_rule_entry_get_f)(int unit, int port, pm_info_t pm_info, uint32 modulo_rule_num, cprimod_transmission_rule_type_t modulo_rule_type, cprimod_modulo_rule_entry_t* modulo_rule);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rsvd4_dbm_position_entry_set_f)(int unit, int port, pm_info_t pm_info, uint32 index, const cprimod_dbm_pos_table_entry_t* pos_entry);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rsvd4_dbm_position_entry_get_f)(int unit, int port, pm_info_t pm_info, uint32 index, cprimod_dbm_pos_table_entry_t* pos_entry);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rsvd4_rx_master_frame_sync_config_set_f)(int unit, int port, pm_info_t pm_info, uint32 master_frame_number, uint64 master_frame_start_time);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rsvd4_rx_master_frame_sync_config_get_f)(int unit, int port, pm_info_t pm_info, uint32* master_frame_number, uint64* master_frame_start_time);
#endif /* CPRIMOD_SUPPORT */
typedef int (*__dispatch__portmod_port_vcos_get_f)(int unit, int port, pm_info_t pm_info, const portmod_vcos_speed_config_t* speed_config_list, int size, portmod_dual_vcos_t* dual_vco);
typedef int (*__dispatch__portmod_port_mac_timestamp_enable_set_f)(int unit, int port, pm_info_t pm_info, int enable);
typedef int (*__dispatch__portmod_port_mac_timestamp_enable_get_f)(int unit, int port, pm_info_t pm_info, int* enable);
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_cw_sync_info_get_f)(int unit, int port, pm_info_t pm_info, uint32* hyper_frame_num, uint32* radio_frame_num);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_cw_l1_signal_info_get_f)(int unit, int port, pm_info_t pm_info, portmod_cpri_cw_l1_protocol_info_t* l1_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_cw_l1_signal_signal_protection_set_f)(int unit, int port, pm_info_t pm_info, uint32 signal_map, uint32 enable);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_cw_l1_signal_signal_protection_get_f)(int unit, int port, pm_info_t pm_info, uint32 signal_map, uint32* enable);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_cw_slow_hdlc_config_set_f)(int unit, int port, pm_info_t pm_info, const portmod_cpri_slow_hdlc_config_info_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_cw_slow_hdlc_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_cpri_slow_hdlc_config_info_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_cw_fast_eth_config_set_f)(int unit, int port, pm_info_t pm_info, const portmod_cpri_fast_eth_config_info_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_cw_fast_eth_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_cpri_fast_eth_config_info_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_vsd_config_set_f)(int unit, int port, pm_info_t pm_info, const portmod_cpri_rx_vsd_config_info_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_vsd_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_cpri_rx_vsd_config_info_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_vsd_config_set_f)(int unit, int port, pm_info_t pm_info, const portmod_cpri_tx_vsd_config_info_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_vsd_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_cpri_tx_vsd_config_info_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_vsd_flow_add_f)(int unit, int port, pm_info_t pm_info, uint32 group_id, const portmod_cpri_rx_vsd_flow_info_t* flow_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_vsd_flow_get_f)(int unit, int port, pm_info_t pm_info, uint32 group_id, portmod_cpri_rx_vsd_flow_info_t* flow_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_vsd_flow_add_f)(int unit, int port, pm_info_t pm_info, uint32 group_id, const portmod_cpri_tx_vsd_flow_info_t* flow_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_vsd_flow_get_f)(int unit, int port, pm_info_t pm_info, uint32 group_id, portmod_cpri_tx_vsd_flow_info_t* flow_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_encap_queue_control_tag_to_flow_map_set_f)(int unit, int port, pm_info_t pm_info, uint32 tag_id, uint32 flow_id);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_encap_queue_control_tag_to_flow_map_get_f)(int unit, int port, pm_info_t pm_info, uint32 tag_id, uint32* flow_id);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_vsd_raw_config_set_f)(int unit, int port, pm_info_t pm_info, uint32 index, const portmod_cpri_rx_vsd_raw_config_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_vsd_raw_config_get_f)(int unit, int port, pm_info_t pm_info, uint32 index, portmod_cpri_rx_vsd_raw_config_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_vsd_raw_config_set_f)(int unit, int port, pm_info_t pm_info, uint32 index, const portmod_cpri_tx_vsd_raw_config_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_vsd_raw_config_get_f)(int unit, int port, pm_info_t pm_info, uint32 index, portmod_cpri_tx_vsd_raw_config_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_vsd_raw_filter_set_f)(int unit, int port, pm_info_t pm_info, uint32 bfn0_value, uint32 bfn0_mask, uint32 bfn1_value, uint32 bfn1_mask);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_vsd_raw_filter_get_f)(int unit, int port, pm_info_t pm_info, uint32* bfn0_value, uint32* bfn0_mask, uint32* bfn1_value, uint32* bfn1_mask);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_brcm_rsvd5_config_set_f)(int unit, int port, pm_info_t pm_info, const portmod_cpri_rx_brcm_rsvd5_config_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_brcm_rsvd5_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_cpri_rx_brcm_rsvd5_config_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_brcm_rsvd5_config_set_f)(int unit, int port, pm_info_t pm_info, const portmod_cpri_tx_brcm_rsvd5_config_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_brcm_rsvd5_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_cpri_tx_brcm_rsvd5_config_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_gcw_config_set_f)(int unit, int port, pm_info_t pm_info, uint32 index, const portmod_cpri_rx_gcw_config_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_gcw_config_get_f)(int unit, int port, pm_info_t pm_info, uint32 index, portmod_cpri_rx_gcw_config_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_gcw_config_set_f)(int unit, int port, pm_info_t pm_info, uint32 index, const portmod_cpri_tx_gcw_config_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_gcw_config_get_f)(int unit, int port, pm_info_t pm_info, uint32 index, portmod_cpri_tx_gcw_config_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_gcw_filter_set_f)(int unit, int port, pm_info_t pm_info, uint32 bfn0_value, uint32 bfn0_mask, uint32 bfn1_value, uint32 bfn1_mask);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_gcw_filter_get_f)(int unit, int port, pm_info_t pm_info, uint32* bfn0_value, uint32* bfn0_mask, uint32* bfn1_value, uint32* bfn1_mask);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_cw_sync_info_set_f)(int unit, int port, pm_info_t pm_info, uint32 hyper_frame_num, uint32 radio_frame_num);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_cw_sync_info_get_f)(int unit, int port, pm_info_t pm_info, uint32* hyper_frame_num, uint32* radio_frame_num);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_cw_l1_config_set_f)(int unit, int port, pm_info_t pm_info, const portmod_cpri_cw_l1_config_info_t* control_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_rsvd4_rx_control_flow_add_f)(int unit, int port, pm_info_t pm_info, uint32 flow_id, const portmod_control_flow_config_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_rsvd4_rx_control_flow_delete_f)(int unit, int port, pm_info_t pm_info, uint32 flow_id, const portmod_control_flow_config_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_rsvd4_fast_eth_config_set_f)(int unit, int port, pm_info_t pm_info, const portmod_cpri_fast_eth_config_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_rsvd4_rx_sync_profile_entry_set_f)(int unit, int port, pm_info_t pm_info, uint32 profile_id, const portmod_sync_profile_entry_t* entry);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_rsvd4_rx_sync_profile_entry_get_f)(int unit, int port, pm_info_t pm_info, uint32 profile_id, portmod_sync_profile_entry_t* entry);
#endif /* CPRIMOD_SUPPORT */
typedef int (*__dispatch__portmod_rx_tag_config_set_f)(int unit, int port, pm_info_t pm_info, uint32 default_tag, uint32 no_match_tag);
typedef int (*__dispatch__portmod_rx_tag_gen_entry_add_f)(int unit, int port, pm_info_t pm_info, const portmod_tag_gen_entry_t* entry);
typedef int (*__dispatch__portmod_rx_tag_gen_entry_delete_f)(int unit, int port, pm_info_t pm_info, const portmod_tag_gen_entry_t* entry);
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_rsvd4_tx_control_flow_group_member_add_f)(int unit, int port, pm_info_t pm_info, uint32 group_id, uint32 priority, uint32 queue_num, portmod_control_msg_proc_type_t proc_type);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_rsvd4_tx_control_flow_group_member_delete_f)(int unit, int port, pm_info_t pm_info, uint32 group_id, uint32 priority);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_rsvd4_tx_eth_message_config_set_f)(int unit, int port, pm_info_t pm_info, uint32 msg_node, uint32 msg_subnode, uint32 msg_type, uint32 msg_padding);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_rsvd4_tx_single_raw_message_config_set_f)(int unit, int port, pm_info_t pm_info, uint32 msg_id, uint32 msg_type);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_rsvd4_tx_control_flow_config_set_f)(int unit, int port, pm_info_t pm_info, uint32 flow_id, const portmod_rsvd4_tx_config_info_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_rsvd4_tx_control_flow_config_get_f)(int unit, int port, pm_info_t pm_info, uint32 flow_id, portmod_rsvd4_tx_config_info_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_rsvd4_tx_control_flow_header_index_set_f)(int unit, int port, pm_info_t pm_info, uint32 roe_flow_id, uint32 index);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_rsvd4_tx_control_flow_header_index_get_f)(int unit, int port, pm_info_t pm_info, uint32 roe_flow_id, uint32* index);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_rsvd4_tx_control_header_entry_set_f)(int unit, int port, pm_info_t pm_info, uint32 index, uint32 header_node, uint32 header_subnode, uint32 payload_node);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_rsvd4_tx_control_header_entry_get_f)(int unit, int port, pm_info_t pm_info, uint32 index, uint32* header_node, uint32* header_subnode, uint32* payload_node);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_rsvd4_tx_single_tunnel_message_config_set_f)(int unit, int port, pm_info_t pm_info, portmod_cpri_crc_option_t crc_option);
#endif /* CPRIMOD_SUPPORT */
typedef int (*__dispatch__portmod_port_txpi_override_set_f)(int unit, int port, pm_info_t pm_info, const portmod_txpi_override_t* override);
typedef int (*__dispatch__portmod_port_txpi_override_get_f)(int unit, int port, pm_info_t pm_info, portmod_txpi_override_t* override);
typedef int (*__dispatch__portmod_port_txpi_sdm_data_get_f)(int unit, int port, pm_info_t pm_info, int* value);
typedef int (*__dispatch__portmod_pm_speed_config_validate_f)(int unit, int pm_id, pm_info_t pm_info, const portmod_pbmp_t* ports, int flag, portmod_pm_vco_setting_t* vco_setting);
typedef int (*__dispatch__portmod_pm_vcos_get_f)(int unit, portmod_dispatch_type_t pm_type, uint32 flags, portmod_pm_vco_setting_t* vco_select);
typedef int (*__dispatch__portmod_pm_specific_vcos_get_f)(int unit, const portmod_pm_capability_t* pm_cap, portmod_pm_vco_setting_t* vco_select);
typedef int (*__dispatch__portmod_port_autoneg_ability_advert_set_f)(int unit, int port, pm_info_t pm_info, int num_abilities, const portmod_port_speed_ability_t* abilities);
typedef int (*__dispatch__portmod_port_autoneg_ability_advert_get_f)(int unit, int port, pm_info_t pm_info, int max_num_abilities, portmod_port_speed_ability_t* abilities, int* actual_num_abilities);
typedef int (*__dispatch__portmod_port_autoneg_ability_remote_get_f)(int unit, int port, pm_info_t pm_info, int max_num_abilities, portmod_port_speed_ability_t* abilities, int* actual_num_abilities);
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_interrupt_link_status_get_f)(int unit, int port, pm_info_t pm_info, const int* is_link_intr_status);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_interrupt_enable_set_f)(int unit, int port, pm_info_t pm_info, portmod_cpri_port_intr_type_t cpri_intr_type, int data, int enable);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_interrupt_process_f)(int unit, int port, pm_info_t pm_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_fast_clk_bit_time_period_set_f)(int unit, int port, pm_info_t pm_info, cprimod_port_speed_t speed);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_fast_clk_bit_time_period_get_f)(int unit, int port, pm_info_t pm_info, uint32* bit_time_period);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_1588_bit_time_period_set_f)(int unit, int port, pm_info_t pm_info, portmod_direction_t direction, cprimod_port_speed_t speed);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_1588_bit_time_period_get_f)(int unit, int port, pm_info_t pm_info, portmod_direction_t direction, uint32* bit_time_period);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_1588_timestamp_capture_config_set_f)(int unit, int port, pm_info_t pm_info, portmod_direction_t direction, const cprimod_1588_capture_config_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_1588_timestamp_capture_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_direction_t direction, cprimod_1588_capture_config_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_1588_captured_timestamp_get_f)(int unit, int port, pm_info_t pm_info, portmod_direction_t direction, portmod_1588_ts_type_t ts_type, uint8 mx_cnt, uint8* count, uint64* captured_time);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_1588_timestamp_adjust_set_f)(int unit, int port, pm_info_t pm_info, portmod_direction_t direction, const cprimod_1588_time_t* adjust_time);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_1588_timestamp_adjust_get_f)(int unit, int port, pm_info_t pm_info, portmod_direction_t direction, cprimod_1588_time_t* adjust_time);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_1588_timestamp_fifo_config_set_f)(int unit, int port, pm_info_t pm_info, portmod_direction_t direction, uint16 modulo);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_1588_timestamp_fifo_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_direction_t direction, uint16* modulo);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_1588_timestamp_cmic_config_set_f)(int unit, int port, pm_info_t pm_info, portmod_direction_t direction, uint16 modulo);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_1588_timestamp_cmic_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_direction_t direction, uint16* modulo);
#endif /* CPRIMOD_SUPPORT */
typedef int (*__dispatch__portmod_port_tx_set_f)(int unit, int port, pm_info_t pm_info, const phymod_tx_t* tx);
typedef int (*__dispatch__portmod_port_tx_get_f)(int unit, int port, pm_info_t pm_info, phymod_tx_t* tx);
typedef int (*__dispatch__portmod_port_synce_clk_ctrl_set_f)(int unit, int port, pm_info_t pm_info, const portmod_port_synce_clk_ctrl_t* cfg);
typedef int (*__dispatch__portmod_port_synce_clk_ctrl_get_f)(int unit, int port, pm_info_t pm_info, portmod_port_synce_clk_ctrl_t* cfg);
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_agnostic_config_set_f)(int unit, int port, pm_info_t pm_info, int enable, const portmod_cpri_rx_agnostic_config_info_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_agnostic_config_get_f)(int unit, int port, pm_info_t pm_info, int* enable, portmod_cpri_rx_agnostic_config_info_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_agnostic_config_set_f)(int unit, int port, pm_info_t pm_info, int enable, const portmod_cpri_tx_agnostic_config_info_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_agnostic_config_get_f)(int unit, int port, pm_info_t pm_info, int* enable, portmod_cpri_tx_agnostic_config_info_t* config_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_encap_presentation_time_config_set_f)(int unit, int port, pm_info_t pm_info, portmod_presentation_time_attribute_t attribute, const portmod_presentation_time_t* time);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_encap_presentation_time_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_presentation_time_attribute_t attribute, portmod_presentation_time_t* time);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_decap_presentation_time_config_set_f)(int unit, int port, pm_info_t pm_info, const portmod_decap_presentation_time_config_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_decap_presentation_time_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_decap_presentation_time_config_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_compression_lookup_table_set_f)(int unit, int port, pm_info_t pm_info, int table_depth, const uint32* table);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_compression_lookup_table_get_f)(int unit, int port, pm_info_t pm_info, int max_depth, int* table_depth, uint32* table);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_decompression_lookup_table_set_f)(int unit, int port, pm_info_t pm_info, int table_depth, const uint32* table);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_decompression_lookup_table_get_f)(int unit, int port, pm_info_t pm_info, int max_depth, int* table_depth, uint32* table);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_decap_queue_flow_control_set_f)(int unit, int port, pm_info_t pm_info, uint32 queue_num, int enable, uint32_t xon_threshold, uint32_t xoff_threshold);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_decap_queue_flow_control_get_f)(int unit, int port, pm_info_t pm_info, uint32 queue_num, int* enable, uint32_t* xon_threshold, uint32_t* xoff_threshold);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_fec_enable_set_f)(int unit, int port, pm_info_t pm_info, portmod_direction_t dir, int enable);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_fec_enable_get_f)(int unit, int port, pm_info_t pm_info, portmod_direction_t dir, int* enable);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_fec_timestamp_config_set_f)(int unit, int port, pm_info_t pm_info, portmod_direction_t dir, const portmod_fec_timestamp_config_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_fec_timestamp_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_direction_t dir, portmod_fec_timestamp_config_t* config);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_fec_aux_config_set_f)(int unit, int port, pm_info_t pm_info, portmod_fec_aux_config_para_t parameter_id, uint32 value);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_fec_aux_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_fec_aux_config_para_t parameter_id, uint32* value);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_ecc_interrupt_enable_set_f)(int unit, int port, pm_info_t pm_info, int enable);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_ecc_interrupt_status_get_f)(int unit, int port, pm_info_t pm_info, const portmod_cpri_ecc_intr_info_t* ecc_err_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_init_f)(int unit, int port, pm_info_t pm_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_rx_gcw_word_get_f)(int unit, int port, pm_info_t pm_info, int group_index, uint16* gcw_word);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__portmod_cpri_port_tx_gcw_word_set_f)(int unit, int port, pm_info_t pm_info, int group_index, uint16 gcw_word);
#endif /* CPRIMOD_SUPPORT */
typedef int (*__dispatch__portmod_pm_interrupt_process_f)(int unit, int pm_id, pm_info_t pm_info, portmod_ecc_intr_info_t* ecc_err_info);
typedef int (*__dispatch__portmod_pm_core_num_get_f)(int unit, pm_info_t pm_info, int* core_num);
typedef int (*__dispatch__portmod_port_rlm_config_set_f)(int unit, int port, pm_info_t pm_info, int enable, const portmod_port_rlm_config_t* rlm_config);
typedef int (*__dispatch__portmod_port_rlm_config_get_f)(int unit, int port, pm_info_t pm_info, int* enable, portmod_port_rlm_config_t* rlm_status);
typedef int (*__dispatch__portmod_port_rlm_status_get_f)(int unit, int port, pm_info_t pm_info, portmod_port_rlm_status_t* rlm_status);

typedef struct __portmod__dispatch__s__ {
    __dispatch__portmod_port_speed_ability_local_get_f                               f_portmod_port_speed_ability_local_get;
    __dispatch__portmod_pm_interface_type_is_supported_f                             f_portmod_pm_interface_type_is_supported;
    __dispatch__portmod_pm_init_f                                                    f_portmod_pm_init;
    __dispatch__portmod_pm_destroy_f                                                 f_portmod_pm_destroy;
    __dispatch__portmod_port_attach_f                                                f_portmod_port_attach;
    __dispatch__portmod_default_bus_update_f                                         f_portmod_default_bus_update;
    __dispatch__portmod_pm_bypass_set_f                                              f_portmod_pm_bypass_set;
    __dispatch__portmod_pm_core_info_get_f                                           f_portmod_pm_core_info_get;
    __dispatch__portmod_pm_phys_get_f                                                f_portmod_pm_phys_get;
    __dispatch__portmod_port_detach_f                                                f_portmod_port_detach;
    __dispatch__portmod_port_replace_f                                               f_portmod_port_replace;
    __dispatch__portmod_port_enable_set_f                                            f_portmod_port_enable_set;
    __dispatch__portmod_port_enable_get_f                                            f_portmod_port_enable_get;
    __dispatch__portmod_port_cdr_lock_get_f                                          f_portmod_port_cdr_lock_get;
    __dispatch__portmod_port_interface_config_set_f                                  f_portmod_port_interface_config_set;
    __dispatch__portmod_port_interface_config_get_f                                  f_portmod_port_interface_config_get;
    __dispatch__portmod_port_default_interface_get_f                                 f_portmod_port_default_interface_get;
    __dispatch__portmod_port_interface_check_f                                       f_portmod_port_interface_check;
    __dispatch__portmod_port_encoding_set_f                                          f_portmod_port_encoding_set;
    __dispatch__portmod_port_encoding_get_f                                          f_portmod_port_encoding_get;
    __dispatch__portmod_port_cl72_set_f                                              f_portmod_port_cl72_set;
    __dispatch__portmod_port_cl72_get_f                                              f_portmod_port_cl72_get;
    __dispatch__portmod_port_cl72_status_get_f                                       f_portmod_port_cl72_status_get;
    __dispatch__portmod_port_loopback_set_f                                          f_portmod_port_loopback_set;
    __dispatch__portmod_port_loopback_get_f                                          f_portmod_port_loopback_get;
    __dispatch__portmod_port_pass_through_set_f                                      f_portmod_port_pass_through_set;
    __dispatch__portmod_port_pass_through_get_f                                      f_portmod_port_pass_through_get;
    __dispatch__portmod_port_pass_through_calibrate_f                                f_portmod_port_pass_through_calibrate;
    __dispatch__portmod_port_pass_through_fec_enable_set_f                           f_portmod_port_pass_through_fec_enable_set;
    __dispatch__portmod_port_pass_through_fec_enable_get_f                           f_portmod_port_pass_through_fec_enable_get;
    __dispatch__portmod_port_rx_mac_enable_set_f                                     f_portmod_port_rx_mac_enable_set;
    __dispatch__portmod_port_rx_mac_enable_get_f                                     f_portmod_port_rx_mac_enable_get;
    __dispatch__portmod_port_tx_mac_enable_set_f                                     f_portmod_port_tx_mac_enable_set;
    __dispatch__portmod_port_tx_mac_enable_get_f                                     f_portmod_port_tx_mac_enable_get;
    __dispatch__portmod_port_ability_local_get_f                                     f_portmod_port_ability_local_get;
    __dispatch__portmod_port_autoneg_set_f                                           f_portmod_port_autoneg_set;
    __dispatch__portmod_port_autoneg_get_f                                           f_portmod_port_autoneg_get;
    __dispatch__portmod_port_autoneg_status_get_f                                    f_portmod_port_autoneg_status_get;
    __dispatch__portmod_port_link_get_f                                              f_portmod_port_link_get;
    __dispatch__portmod_port_link_latch_down_get_f                                   f_portmod_port_link_latch_down_get;
    __dispatch__portmod_port_phy_link_up_event_f                                     f_portmod_port_phy_link_up_event;
    __dispatch__portmod_port_phy_link_down_event_f                                   f_portmod_port_phy_link_down_event;
    __dispatch__portmod_port_prbs_config_set_f                                       f_portmod_port_prbs_config_set;
    __dispatch__portmod_port_prbs_config_get_f                                       f_portmod_port_prbs_config_get;
    __dispatch__portmod_port_prbs_enable_set_f                                       f_portmod_port_prbs_enable_set;
    __dispatch__portmod_port_prbs_enable_get_f                                       f_portmod_port_prbs_enable_get;
    __dispatch__portmod_port_prbs_status_get_f                                       f_portmod_port_prbs_status_get;
    __dispatch__portmod_port_nof_lanes_get_f                                         f_portmod_port_nof_lanes_get;
    __dispatch__portmod_port_ilkn_nof_segments_set_f                                 f_portmod_port_ilkn_nof_segments_set;
    __dispatch__portmod_port_ilkn_nof_segments_get_f                                 f_portmod_port_ilkn_nof_segments_get;
    __dispatch__portmod_ilkn_retranstmit_config_set_f                                f_portmod_ilkn_retranstmit_config_set;
    __dispatch__portmod_ilkn_retranstmit_config_get_f                                f_portmod_ilkn_retranstmit_config_get;
    __dispatch__portmod_port_lanes_assign_f                                          f_portmod_port_lanes_assign;
    __dispatch__portmod_port_lanes_retrieve_f                                        f_portmod_port_lanes_retrieve;
    __dispatch__portmod_port_firmware_mode_set_f                                     f_portmod_port_firmware_mode_set;
    __dispatch__portmod_port_firmware_mode_get_f                                     f_portmod_port_firmware_mode_get;
    __dispatch__portmod_port_runt_threshold_set_f                                    f_portmod_port_runt_threshold_set;
    __dispatch__portmod_port_runt_threshold_get_f                                    f_portmod_port_runt_threshold_get;
    __dispatch__portmod_port_max_packet_size_set_f                                   f_portmod_port_max_packet_size_set;
    __dispatch__portmod_port_max_packet_size_get_f                                   f_portmod_port_max_packet_size_get;
    __dispatch__portmod_port_pad_size_set_f                                          f_portmod_port_pad_size_set;
    __dispatch__portmod_port_pad_size_get_f                                          f_portmod_port_pad_size_get;
    __dispatch__portmod_port_tx_mac_sa_set_f                                         f_portmod_port_tx_mac_sa_set;
    __dispatch__portmod_port_tx_mac_sa_get_f                                         f_portmod_port_tx_mac_sa_get;
    __dispatch__portmod_port_rx_mac_sa_set_f                                         f_portmod_port_rx_mac_sa_set;
    __dispatch__portmod_port_rx_mac_sa_get_f                                         f_portmod_port_rx_mac_sa_get;
    __dispatch__portmod_port_tx_average_ipg_set_f                                    f_portmod_port_tx_average_ipg_set;
    __dispatch__portmod_port_tx_average_ipg_get_f                                    f_portmod_port_tx_average_ipg_get;
    __dispatch__portmod_port_tx_preamble_length_set_f                                f_portmod_port_tx_preamble_length_set;
    __dispatch__portmod_port_tx_preamble_length_get_f                                f_portmod_port_tx_preamble_length_get;
    __dispatch__portmod_port_local_fault_control_set_f                               f_portmod_port_local_fault_control_set;
    __dispatch__portmod_port_local_fault_control_get_f                               f_portmod_port_local_fault_control_get;
    __dispatch__portmod_port_remote_fault_control_set_f                              f_portmod_port_remote_fault_control_set;
    __dispatch__portmod_port_remote_fault_control_get_f                              f_portmod_port_remote_fault_control_get;
    __dispatch__portmod_port_local_fault_status_get_f                                f_portmod_port_local_fault_status_get;
    __dispatch__portmod_port_remote_fault_status_get_f                               f_portmod_port_remote_fault_status_get;
    __dispatch__portmod_port_local_fault_status_clear_f                              f_portmod_port_local_fault_status_clear;
    __dispatch__portmod_port_remote_fault_status_clear_f                             f_portmod_port_remote_fault_status_clear;
    __dispatch__portmod_port_pause_control_set_f                                     f_portmod_port_pause_control_set;
    __dispatch__portmod_port_pause_control_get_f                                     f_portmod_port_pause_control_get;
    __dispatch__portmod_port_pfc_control_set_f                                       f_portmod_port_pfc_control_set;
    __dispatch__portmod_port_pfc_control_get_f                                       f_portmod_port_pfc_control_get;
    __dispatch__portmod_port_llfc_control_set_f                                      f_portmod_port_llfc_control_set;
    __dispatch__portmod_port_llfc_control_get_f                                      f_portmod_port_llfc_control_get;
    __dispatch__portmod_port_update_f                                                f_portmod_port_update;
    __dispatch__portmod_port_core_access_get_f                                       f_portmod_port_core_access_get;
    __dispatch__portmod_port_phy_lane_access_get_f                                   f_portmod_port_phy_lane_access_get;
    __dispatch__portmod_pm_phy_lane_access_get_f                                     f_portmod_pm_phy_lane_access_get;
    __dispatch__portmod_port_duplex_set_f                                            f_portmod_port_duplex_set;
    __dispatch__portmod_port_duplex_get_f                                            f_portmod_port_duplex_get;
    __dispatch__portmod_port_phy_reg_read_f                                          f_portmod_port_phy_reg_read;
    __dispatch__portmod_port_phy_reg_write_f                                         f_portmod_port_phy_reg_write;
    __dispatch__portmod_port_reset_set_f                                             f_portmod_port_reset_set;
    __dispatch__portmod_port_reset_get_f                                             f_portmod_port_reset_get;
    __dispatch__portmod_port_adv_remote_get_f                                        f_portmod_port_adv_remote_get;
    __dispatch__portmod_port_drv_name_f                                              f_portmod_port_drv_name;
    __dispatch__portmod_port_drv_name_get_f                                          f_portmod_port_drv_name_get;
    __dispatch__portmod_port_fec_enable_set_f                                        f_portmod_port_fec_enable_set;
    __dispatch__portmod_port_fec_enable_get_f                                        f_portmod_port_fec_enable_get;
    __dispatch__portmod_port_ability_advert_set_f                                    f_portmod_port_ability_advert_set;
    __dispatch__portmod_port_ability_advert_get_f                                    f_portmod_port_ability_advert_get;
    __dispatch__portmod_port_ability_remote_get_f                                    f_portmod_port_ability_remote_get;
    __dispatch__portmod_port_frame_spacing_stretch_set_f                             f_portmod_port_frame_spacing_stretch_set;
    __dispatch__portmod_port_frame_spacing_stretch_get_f                             f_portmod_port_frame_spacing_stretch_get;
    __dispatch__portmod_port_diag_fifo_status_get_f                                  f_portmod_port_diag_fifo_status_get;
    __dispatch__portmod_port_rx_control_set_f                                        f_portmod_port_rx_control_set;
    __dispatch__portmod_port_rx_control_get_f                                        f_portmod_port_rx_control_get;
    __dispatch__portmod_port_pfc_config_set_f                                        f_portmod_port_pfc_config_set;
    __dispatch__portmod_port_pfc_config_get_f                                        f_portmod_port_pfc_config_get;
    __dispatch__portmod_port_eee_set_f                                               f_portmod_port_eee_set;
    __dispatch__portmod_port_eee_get_f                                               f_portmod_port_eee_get;
    __dispatch__portmod_port_eee_clock_set_f                                         f_portmod_port_eee_clock_set;
    __dispatch__portmod_port_eee_clock_get_f                                         f_portmod_port_eee_clock_get;
    __dispatch__portmod_port_vlan_tag_set_f                                          f_portmod_port_vlan_tag_set;
    __dispatch__portmod_port_vlan_tag_get_f                                          f_portmod_port_vlan_tag_get;
    __dispatch__portmod_port_modid_set_f                                             f_portmod_port_modid_set;
    __dispatch__portmod_port_led_chain_config_f                                      f_portmod_port_led_chain_config;
    __dispatch__portmod_port_clear_rx_lss_status_set_f                               f_portmod_port_clear_rx_lss_status_set;
    __dispatch__portmod_port_clear_rx_lss_status_get_f                               f_portmod_port_clear_rx_lss_status_get;
    __dispatch__portmod_xphy_lane_attach_to_pm_f                                     f_portmod_xphy_lane_attach_to_pm;
    __dispatch__portmod_xphy_lane_detach_from_pm_f                                   f_portmod_xphy_lane_detach_from_pm;
    __dispatch__portmod_ext_phy_lane_attach_to_pm_f                                  f_portmod_ext_phy_lane_attach_to_pm;
    __dispatch__portmod_ext_phy_lane_detach_from_pm_f                                f_portmod_ext_phy_lane_detach_from_pm;
    __dispatch__portmod_port_lag_failover_status_toggle_f                            f_portmod_port_lag_failover_status_toggle;
    __dispatch__portmod_port_lag_failover_loopback_set_f                             f_portmod_port_lag_failover_loopback_set;
    __dispatch__portmod_port_lag_failover_loopback_get_f                             f_portmod_port_lag_failover_loopback_get;
    __dispatch__portmod_port_mode_set_f                                              f_portmod_port_mode_set;
    __dispatch__portmod_port_mode_get_f                                              f_portmod_port_mode_get;
    __dispatch__portmod_port_encap_set_f                                             f_portmod_port_encap_set;
    __dispatch__portmod_port_encap_get_f                                             f_portmod_port_encap_get;
    __dispatch__portmod_port_higig_mode_set_f                                        f_portmod_port_higig_mode_set;
    __dispatch__portmod_port_higig_mode_get_f                                        f_portmod_port_higig_mode_get;
    __dispatch__portmod_port_higig2_mode_set_f                                       f_portmod_port_higig2_mode_set;
    __dispatch__portmod_port_higig2_mode_get_f                                       f_portmod_port_higig2_mode_get;
    __dispatch__portmod_port_config_port_type_set_f                                  f_portmod_port_config_port_type_set;
    __dispatch__portmod_port_config_port_type_get_f                                  f_portmod_port_config_port_type_get;
    __dispatch__portmod_port_trunk_hwfailover_config_set_f                           f_portmod_port_trunk_hwfailover_config_set;
    __dispatch__portmod_port_trunk_hwfailover_config_get_f                           f_portmod_port_trunk_hwfailover_config_get;
    __dispatch__portmod_port_trunk_hwfailover_status_get_f                           f_portmod_port_trunk_hwfailover_status_get;
    __dispatch__portmod_port_diag_ctrl_f                                             f_portmod_port_diag_ctrl;
    __dispatch__portmod_port_ref_clk_get_f                                           f_portmod_port_ref_clk_get;
    __dispatch__portmod_port_lag_failover_disable_f                                  f_portmod_port_lag_failover_disable;
    __dispatch__portmod_port_lag_remove_failover_lpbk_set_f                          f_portmod_port_lag_remove_failover_lpbk_set;
    __dispatch__portmod_port_lag_remove_failover_lpbk_get_f                          f_portmod_port_lag_remove_failover_lpbk_get;
    __dispatch__portmod_port_cntmaxsize_set_f                                        f_portmod_port_cntmaxsize_set;
    __dispatch__portmod_port_cntmaxsize_get_f                                        f_portmod_port_cntmaxsize_get;
    __dispatch__portmod_port_multi_get_f                                             f_portmod_port_multi_get;
    __dispatch__portmod_port_drain_cell_get_f                                        f_portmod_port_drain_cell_get;
    __dispatch__portmod_port_drain_cell_stop_f                                       f_portmod_port_drain_cell_stop;
    __dispatch__portmod_port_drain_cell_start_f                                      f_portmod_port_drain_cell_start;
    __dispatch__portmod_port_drain_cells_rx_enable_f                                 f_portmod_port_drain_cells_rx_enable;
    __dispatch__portmod_port_egress_queue_drain_rx_en_f                              f_portmod_port_egress_queue_drain_rx_en;
    __dispatch__portmod_port_mac_ctrl_set_f                                          f_portmod_port_mac_ctrl_set;
    __dispatch__portmod_port_txfifo_cell_cnt_get_f                                   f_portmod_port_txfifo_cell_cnt_get;
    __dispatch__portmod_port_egress_queue_drain_get_f                                f_portmod_port_egress_queue_drain_get;
    __dispatch__portmod_port_mac_reset_set_f                                         f_portmod_port_mac_reset_set;
    __dispatch__portmod_port_mac_reset_get_f                                         f_portmod_port_mac_reset_get;
    __dispatch__portmod_port_soft_reset_toggle_f                                     f_portmod_port_soft_reset_toggle;
    __dispatch__portmod_port_mac_reset_check_f                                       f_portmod_port_mac_reset_check;
    __dispatch__portmod_port_core_num_get_f                                          f_portmod_port_core_num_get;
    __dispatch__portmod_port_e2ecc_hdr_set_f                                         f_portmod_port_e2ecc_hdr_set;
    __dispatch__portmod_port_e2ecc_hdr_get_f                                         f_portmod_port_e2ecc_hdr_get;
    __dispatch__portmod_port_e2e_enable_set_f                                        f_portmod_port_e2e_enable_set;
    __dispatch__portmod_port_e2e_enable_get_f                                        f_portmod_port_e2e_enable_get;
    __dispatch__portmod_port_fallback_lane_get_f                                     f_portmod_port_fallback_lane_get;
    __dispatch__portmod_port_speed_get_f                                             f_portmod_port_speed_get;
    __dispatch__portmod_port_tsc_refclock_set_f                                      f_portmod_port_tsc_refclock_set;
    __dispatch__portmod_port_tsc_refclock_get_f                                      f_portmod_port_tsc_refclock_get;
    __dispatch__portmod_port_discard_set_f                                           f_portmod_port_discard_set;
    __dispatch__portmod_port_soft_reset_set_f                                        f_portmod_port_soft_reset_set;
    __dispatch__portmod_port_tx_down_f                                               f_portmod_port_tx_down;
    __dispatch__portmod_port_logical_lane_order_set_f                                f_portmod_port_logical_lane_order_set;
    __dispatch__portmod_port_logical_lane_order_get_f                                f_portmod_port_logical_lane_order_get;
    __dispatch__portmod_port_pgw_reconfig_f                                          f_portmod_port_pgw_reconfig;
    __dispatch__portmod_port_notify_f                                                f_portmod_port_notify;
    __dispatch__portmod_port_control_phy_timesync_set_f                              f_portmod_port_control_phy_timesync_set;
    __dispatch__portmod_port_control_phy_timesync_get_f                              f_portmod_port_control_phy_timesync_get;
    __dispatch__portmod_port_timesync_config_set_f                                   f_portmod_port_timesync_config_set;
    __dispatch__portmod_port_timesync_config_get_f                                   f_portmod_port_timesync_config_get;
    __dispatch__portmod_port_timesync_enable_set_f                                   f_portmod_port_timesync_enable_set;
    __dispatch__portmod_port_timesync_enable_get_f                                   f_portmod_port_timesync_enable_get;
    __dispatch__portmod_port_timesync_nco_addend_set_f                               f_portmod_port_timesync_nco_addend_set;
    __dispatch__portmod_port_timesync_nco_addend_get_f                               f_portmod_port_timesync_nco_addend_get;
    __dispatch__portmod_port_timesync_framesync_mode_set_f                           f_portmod_port_timesync_framesync_mode_set;
    __dispatch__portmod_port_timesync_framesync_mode_get_f                           f_portmod_port_timesync_framesync_mode_get;
    __dispatch__portmod_port_timesync_local_time_set_f                               f_portmod_port_timesync_local_time_set;
    __dispatch__portmod_port_timesync_local_time_get_f                               f_portmod_port_timesync_local_time_get;
    __dispatch__portmod_port_timesync_load_ctrl_set_f                                f_portmod_port_timesync_load_ctrl_set;
    __dispatch__portmod_port_timesync_load_ctrl_get_f                                f_portmod_port_timesync_load_ctrl_get;
    __dispatch__portmod_port_timesync_tx_timestamp_offset_set_f                      f_portmod_port_timesync_tx_timestamp_offset_set;
    __dispatch__portmod_port_timesync_tx_timestamp_offset_get_f                      f_portmod_port_timesync_tx_timestamp_offset_get;
    __dispatch__portmod_port_timesync_rx_timestamp_offset_set_f                      f_portmod_port_timesync_rx_timestamp_offset_set;
    __dispatch__portmod_port_timesync_rx_timestamp_offset_get_f                      f_portmod_port_timesync_rx_timestamp_offset_get;
    __dispatch__portmod_port_timestamp_adjust_set_f                                  f_portmod_port_timestamp_adjust_set;
    __dispatch__portmod_port_timestamp_adjust_get_f                                  f_portmod_port_timestamp_adjust_get;
    __dispatch__portmod_port_phy_intr_enable_set_f                                   f_portmod_port_phy_intr_enable_set;
    __dispatch__portmod_port_phy_intr_enable_get_f                                   f_portmod_port_phy_intr_enable_get;
    __dispatch__portmod_port_phy_intr_status_get_f                                   f_portmod_port_phy_intr_status_get;
    __dispatch__portmod_port_phy_intr_status_clear_f                                 f_portmod_port_phy_intr_status_clear;
    __dispatch__portmod_port_phy_timesync_do_sync_f                                  f_portmod_port_phy_timesync_do_sync;
    __dispatch__portmod_port_timesync_capture_timestamp_get_f                        f_portmod_port_timesync_capture_timestamp_get;
    __dispatch__portmod_port_timesync_heartbeat_timestamp_get_f                      f_portmod_port_timesync_heartbeat_timestamp_get;
    __dispatch__portmod_port_edc_config_set_f                                        f_portmod_port_edc_config_set;
    __dispatch__portmod_port_edc_config_get_f                                        f_portmod_port_edc_config_get;
    __dispatch__portmod_port_interrupt_enable_set_f                                  f_portmod_port_interrupt_enable_set;
    __dispatch__portmod_port_interrupt_enable_get_f                                  f_portmod_port_interrupt_enable_get;
    __dispatch__portmod_port_interrupt_get_f                                         f_portmod_port_interrupt_get;
    __dispatch__portmod_port_interrupts_get_f                                        f_portmod_port_interrupts_get;
    __dispatch__portmod_port_check_legacy_phy_f                                      f_portmod_port_check_legacy_phy;
    __dispatch__portmod_port_failover_mode_set_f                                     f_portmod_port_failover_mode_set;
    __dispatch__portmod_port_failover_mode_get_f                                     f_portmod_port_failover_mode_get;
    __dispatch__portmod_port_mac_rsv_mask_set_f                                      f_portmod_port_mac_rsv_mask_set;
    __dispatch__portmod_port_mib_reset_toggle_f                                      f_portmod_port_mib_reset_toggle;
    __dispatch__portmod_port_warmboot_db_restore_f                                   f_portmod_port_warmboot_db_restore;
    __dispatch__portmod_port_flow_control_set_f                                      f_portmod_port_flow_control_set;
    __dispatch__portmod_port_update_dynamic_state_f                                  f_portmod_port_update_dynamic_state;
    __dispatch__portmod_port_phy_op_mode_get_f                                       f_portmod_port_phy_op_mode_get;
    __dispatch__portmod_port_lane_map_set_f                                          f_portmod_port_lane_map_set;
    __dispatch__portmod_port_lane_map_get_f                                          f_portmod_port_lane_map_get;
    __dispatch__portmod_port_polarity_set_f                                          f_portmod_port_polarity_set;
    __dispatch__portmod_port_polarity_get_f                                          f_portmod_port_polarity_get;
    __dispatch__portmod_port_medium_config_set_f                                     f_portmod_port_medium_config_set;
    __dispatch__portmod_port_medium_config_get_f                                     f_portmod_port_medium_config_get;
    __dispatch__portmod_port_medium_get_f                                            f_portmod_port_medium_get;
    __dispatch__portmod_pm_is_in_pm12x10_f                                           f_portmod_pm_is_in_pm12x10;
    __dispatch__portmod_slow_read_rate_set_f                                         f_portmod_slow_read_rate_set;
    __dispatch__portmod_port_pll_div_get_f                                           f_portmod_port_pll_div_get;
    __dispatch__portmod_port_master_set_f                                            f_portmod_port_master_set;
    __dispatch__portmod_port_master_get_f                                            f_portmod_port_master_get;
    __dispatch__portmod_preemption_control_set_f                                     f_portmod_preemption_control_set;
    __dispatch__portmod_preemption_control_get_f                                     f_portmod_preemption_control_get;
    __dispatch__portmod_preemption_tx_status_get_f                                   f_portmod_preemption_tx_status_get;
    __dispatch__portmod_preemption_verify_status_get_f                               f_portmod_preemption_verify_status_get;
    __dispatch__portmod_preemption_force_rx_eop_mode_set_f                           f_portmod_preemption_force_rx_eop_mode_set;
    __dispatch__portmod_preemption_force_rx_eop_mode_get_f                           f_portmod_preemption_force_rx_eop_mode_get;
    __dispatch__portmod_preemption_rx_timeout_set_f                                  f_portmod_preemption_rx_timeout_set;
    __dispatch__portmod_preemption_rx_timeout_get_f                                  f_portmod_preemption_rx_timeout_get;
    __dispatch__portmod_port_lane_count_get_f                                        f_portmod_port_lane_count_get;
    __dispatch__portmod_port_timesync_tx_info_get_f                                  f_portmod_port_timesync_tx_info_get;
    __dispatch__portmod_port_lane_mask_get_f                                         f_portmod_port_lane_mask_get;
    __dispatch__portmod_core_add_f                                                   f_portmod_core_add;
    __dispatch__portmod_pm_serdes_core_init_f                                        f_portmod_pm_serdes_core_init;
    __dispatch__portmod_pm_is_initialized_f                                          f_portmod_pm_is_initialized;
    __dispatch__portmod_port_speed_config_validate_f                                 f_portmod_port_speed_config_validate;
    __dispatch__portmod_pm_enable_f                                                  f_portmod_pm_enable;
    __dispatch__portmod_pm_logical_pbmp_get_f                                        f_portmod_pm_logical_pbmp_get;
    __dispatch__portmod_pm_vco_reconfig_f                                            f_portmod_pm_vco_reconfig;
    __dispatch__portmod_port_speed_config_set_f                                      f_portmod_port_speed_config_set;
    __dispatch__portmod_port_speed_config_get_f                                      f_portmod_port_speed_config_get;
    __dispatch__portmod_fw_bcast_f                                                   f_portmod_fw_bcast;
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_stage_activate_f                                   f_portmod_cpri_port_stage_activate;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rsvd4_tx_fsm_state_set_f                           f_portmod_cpri_port_rsvd4_tx_fsm_state_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rsvd4_tx_override_set_f                            f_portmod_cpri_port_rsvd4_tx_override_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rsvd4_rx_override_set_f                            f_portmod_cpri_port_rsvd4_rx_override_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_axc_frame_add_f                                 f_portmod_cpri_port_rx_axc_frame_add;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_frame_optional_config_set_f                     f_portmod_cpri_port_rx_frame_optional_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_frame_optional_config_get_f                     f_portmod_cpri_port_rx_frame_optional_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_frame_optional_config_set_f                     f_portmod_cpri_port_tx_frame_optional_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_frame_optional_config_get_f                     f_portmod_cpri_port_tx_frame_optional_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_port_rsvd4_rx_frame_optional_config_set_f                    f_portmod_port_rsvd4_rx_frame_optional_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_port_rsvd4_rx_frame_optional_config_get_f                    f_portmod_port_rsvd4_rx_frame_optional_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_port_rsvd4_tx_frame_optional_config_set_f                    f_portmod_port_rsvd4_tx_frame_optional_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_port_rsvd4_tx_frame_optional_config_get_f                    f_portmod_port_rsvd4_tx_frame_optional_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_port_rsvd4_rx_speed_set_f                                    f_portmod_port_rsvd4_rx_speed_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_port_rsvd4_rx_speed_get_f                                    f_portmod_port_rsvd4_rx_speed_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_port_rsvd4_tx_speed_set_f                                    f_portmod_port_rsvd4_tx_speed_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_port_rsvd4_tx_speed_get_f                                    f_portmod_port_rsvd4_tx_speed_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_axc_frame_delete_f                              f_portmod_cpri_port_rx_axc_frame_delete;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_axc_frame_get_f                                 f_portmod_cpri_port_rx_axc_frame_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rsvd4_rx_fsm_state_set_f                           f_portmod_cpri_port_rsvd4_rx_fsm_state_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_axc_frame_add_f                                 f_portmod_cpri_port_tx_axc_frame_add;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_axc_frame_delete_f                              f_portmod_cpri_port_tx_axc_frame_delete;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_axc_frame_get_f                                 f_portmod_cpri_port_tx_axc_frame_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_encap_set_f                                        f_portmod_cpri_port_encap_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_encap_get_f                                        f_portmod_cpri_port_encap_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_encap_roe_ordering_info_set_f                      f_portmod_cpri_port_encap_roe_ordering_info_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_encap_roe_ordering_info_get_f                      f_portmod_cpri_port_encap_roe_ordering_info_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_encap_roe_ordering_sequence_offset_set_f           f_portmod_cpri_port_encap_roe_ordering_sequence_offset_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_encap_roe_ordering_sequence_offset_get_f           f_portmod_cpri_port_encap_roe_ordering_sequence_offset_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_roe_encap_macda_entry_set_f                        f_portmod_cpri_port_roe_encap_macda_entry_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_roe_encap_macda_entry_get_f                        f_portmod_cpri_port_roe_encap_macda_entry_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_roe_encap_macsa_entry_set_f                        f_portmod_cpri_port_roe_encap_macsa_entry_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_roe_encap_macsa_entry_get_f                        f_portmod_cpri_port_roe_encap_macsa_entry_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_roe_encap_vlan_entry_set_f                         f_portmod_cpri_port_roe_encap_vlan_entry_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_roe_encap_vlan_entry_get_f                         f_portmod_cpri_port_roe_encap_vlan_entry_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_decap_ethertype_config_set_f                       f_portmod_cpri_port_decap_ethertype_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_decap_ethertype_config_get_f                       f_portmod_cpri_port_decap_ethertype_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_encap_ethertype_config_set_f                       f_portmod_cpri_port_encap_ethertype_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_encap_ethertype_config_get_f                       f_portmod_cpri_port_encap_ethertype_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_decap_flow_config_set_f                            f_portmod_cpri_port_decap_flow_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_decap_flow_config_get_f                            f_portmod_cpri_port_decap_flow_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_decap_queue_to_ordering_info_index_set_f           f_portmod_cpri_port_decap_queue_to_ordering_info_index_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_decap_queue_to_ordering_info_index_get_f           f_portmod_cpri_port_decap_queue_to_ordering_info_index_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_decap_flow_to_queue_mapping_set_f                  f_portmod_cpri_port_decap_flow_to_queue_mapping_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_decap_flow_to_queue_mapping_get_f                  f_portmod_cpri_port_decap_flow_to_queue_mapping_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_decap_roe_ordering_info_set_f                      f_portmod_cpri_port_decap_roe_ordering_info_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_decap_roe_ordering_info_get_f                      f_portmod_cpri_port_decap_roe_ordering_info_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_decap_roe_ordering_sequence_offset_set_f           f_portmod_cpri_port_decap_roe_ordering_sequence_offset_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_decap_roe_ordering_sequence_offset_get_f           f_portmod_cpri_port_decap_roe_ordering_sequence_offset_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_frame_tgen_config_set_f                         f_portmod_cpri_port_tx_frame_tgen_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_frame_tgen_config_get_f                         f_portmod_cpri_port_tx_frame_tgen_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_frame_tgen_enable_f                             f_portmod_cpri_port_tx_frame_tgen_enable;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_frame_tgen_ts_offset_set_f                      f_portmod_cpri_port_tx_frame_tgen_ts_offset_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_frame_tgen_ts_offset_get_f                      f_portmod_cpri_port_tx_frame_tgen_ts_offset_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_frame_tgen_next_hfn_set_f                       f_portmod_cpri_port_tx_frame_tgen_next_hfn_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_frame_tgen_next_hfn_get_f                       f_portmod_cpri_port_tx_frame_tgen_next_hfn_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_frame_tgen_next_bfn_set_f                       f_portmod_cpri_port_tx_frame_tgen_next_bfn_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_frame_tgen_next_bfn_get_f                       f_portmod_cpri_port_tx_frame_tgen_next_bfn_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rsvd4_rx_flow_add_f                                f_portmod_cpri_port_rsvd4_rx_flow_add;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rsvd4_rx_flow_delete_f                             f_portmod_cpri_port_rsvd4_rx_flow_delete;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rsvd4_tx_flow_add_f                                f_portmod_cpri_port_rsvd4_tx_flow_add;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rsvd4_tx_flow_delete_f                             f_portmod_cpri_port_rsvd4_tx_flow_delete;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rsvd4_dbm_entry_set_f                              f_portmod_cpri_port_rsvd4_dbm_entry_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rsvd4_dbm_entry_get_f                              f_portmod_cpri_port_rsvd4_dbm_entry_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rsvd4_secondary_dbm_entry_set_f                    f_portmod_cpri_port_rsvd4_secondary_dbm_entry_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rsvd4_secondary_dbm_entry_get_f                    f_portmod_cpri_port_rsvd4_secondary_dbm_entry_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rsvd4_modulo_rule_entry_set_f                      f_portmod_cpri_port_rsvd4_modulo_rule_entry_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rsvd4_modulo_rule_entry_get_f                      f_portmod_cpri_port_rsvd4_modulo_rule_entry_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rsvd4_dbm_position_entry_set_f                     f_portmod_cpri_port_rsvd4_dbm_position_entry_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rsvd4_dbm_position_entry_get_f                     f_portmod_cpri_port_rsvd4_dbm_position_entry_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rsvd4_rx_master_frame_sync_config_set_f            f_portmod_cpri_port_rsvd4_rx_master_frame_sync_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rsvd4_rx_master_frame_sync_config_get_f            f_portmod_cpri_port_rsvd4_rx_master_frame_sync_config_get;
#endif /* CPRIMOD_SUPPORT */
    __dispatch__portmod_port_vcos_get_f                                              f_portmod_port_vcos_get;
    __dispatch__portmod_port_mac_timestamp_enable_set_f                              f_portmod_port_mac_timestamp_enable_set;
    __dispatch__portmod_port_mac_timestamp_enable_get_f                              f_portmod_port_mac_timestamp_enable_get;
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_cw_sync_info_get_f                              f_portmod_cpri_port_rx_cw_sync_info_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_cw_l1_signal_info_get_f                         f_portmod_cpri_port_rx_cw_l1_signal_info_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_cw_l1_signal_signal_protection_set_f            f_portmod_cpri_port_rx_cw_l1_signal_signal_protection_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_cw_l1_signal_signal_protection_get_f            f_portmod_cpri_port_rx_cw_l1_signal_signal_protection_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_cw_slow_hdlc_config_set_f                          f_portmod_cpri_port_cw_slow_hdlc_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_cw_slow_hdlc_config_get_f                          f_portmod_cpri_port_cw_slow_hdlc_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_cw_fast_eth_config_set_f                           f_portmod_cpri_port_cw_fast_eth_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_cw_fast_eth_config_get_f                           f_portmod_cpri_port_cw_fast_eth_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_vsd_config_set_f                                f_portmod_cpri_port_rx_vsd_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_vsd_config_get_f                                f_portmod_cpri_port_rx_vsd_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_vsd_config_set_f                                f_portmod_cpri_port_tx_vsd_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_vsd_config_get_f                                f_portmod_cpri_port_tx_vsd_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_vsd_flow_add_f                                  f_portmod_cpri_port_rx_vsd_flow_add;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_vsd_flow_get_f                                  f_portmod_cpri_port_rx_vsd_flow_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_vsd_flow_add_f                                  f_portmod_cpri_port_tx_vsd_flow_add;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_vsd_flow_get_f                                  f_portmod_cpri_port_tx_vsd_flow_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_encap_queue_control_tag_to_flow_map_set_f          f_portmod_cpri_port_encap_queue_control_tag_to_flow_map_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_encap_queue_control_tag_to_flow_map_get_f          f_portmod_cpri_port_encap_queue_control_tag_to_flow_map_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_vsd_raw_config_set_f                            f_portmod_cpri_port_rx_vsd_raw_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_vsd_raw_config_get_f                            f_portmod_cpri_port_rx_vsd_raw_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_vsd_raw_config_set_f                            f_portmod_cpri_port_tx_vsd_raw_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_vsd_raw_config_get_f                            f_portmod_cpri_port_tx_vsd_raw_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_vsd_raw_filter_set_f                            f_portmod_cpri_port_tx_vsd_raw_filter_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_vsd_raw_filter_get_f                            f_portmod_cpri_port_tx_vsd_raw_filter_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_brcm_rsvd5_config_set_f                         f_portmod_cpri_port_rx_brcm_rsvd5_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_brcm_rsvd5_config_get_f                         f_portmod_cpri_port_rx_brcm_rsvd5_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_brcm_rsvd5_config_set_f                         f_portmod_cpri_port_tx_brcm_rsvd5_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_brcm_rsvd5_config_get_f                         f_portmod_cpri_port_tx_brcm_rsvd5_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_gcw_config_set_f                                f_portmod_cpri_port_rx_gcw_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_gcw_config_get_f                                f_portmod_cpri_port_rx_gcw_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_gcw_config_set_f                                f_portmod_cpri_port_tx_gcw_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_gcw_config_get_f                                f_portmod_cpri_port_tx_gcw_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_gcw_filter_set_f                                f_portmod_cpri_port_tx_gcw_filter_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_gcw_filter_get_f                                f_portmod_cpri_port_tx_gcw_filter_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_cw_sync_info_set_f                              f_portmod_cpri_port_tx_cw_sync_info_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_cw_sync_info_get_f                              f_portmod_cpri_port_tx_cw_sync_info_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_cw_l1_config_set_f                              f_portmod_cpri_port_tx_cw_l1_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_rsvd4_rx_control_flow_add_f                                  f_portmod_rsvd4_rx_control_flow_add;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_rsvd4_rx_control_flow_delete_f                               f_portmod_rsvd4_rx_control_flow_delete;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_rsvd4_fast_eth_config_set_f                                  f_portmod_rsvd4_fast_eth_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_rsvd4_rx_sync_profile_entry_set_f                            f_portmod_rsvd4_rx_sync_profile_entry_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_rsvd4_rx_sync_profile_entry_get_f                            f_portmod_rsvd4_rx_sync_profile_entry_get;
#endif /* CPRIMOD_SUPPORT */
    __dispatch__portmod_rx_tag_config_set_f                                          f_portmod_rx_tag_config_set;
    __dispatch__portmod_rx_tag_gen_entry_add_f                                       f_portmod_rx_tag_gen_entry_add;
    __dispatch__portmod_rx_tag_gen_entry_delete_f                                    f_portmod_rx_tag_gen_entry_delete;
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_rsvd4_tx_control_flow_group_member_add_f                     f_portmod_rsvd4_tx_control_flow_group_member_add;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_rsvd4_tx_control_flow_group_member_delete_f                  f_portmod_rsvd4_tx_control_flow_group_member_delete;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_rsvd4_tx_eth_message_config_set_f                            f_portmod_rsvd4_tx_eth_message_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_rsvd4_tx_single_raw_message_config_set_f                     f_portmod_rsvd4_tx_single_raw_message_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_rsvd4_tx_control_flow_config_set_f                           f_portmod_rsvd4_tx_control_flow_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_rsvd4_tx_control_flow_config_get_f                           f_portmod_rsvd4_tx_control_flow_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_rsvd4_tx_control_flow_header_index_set_f                     f_portmod_rsvd4_tx_control_flow_header_index_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_rsvd4_tx_control_flow_header_index_get_f                     f_portmod_rsvd4_tx_control_flow_header_index_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_rsvd4_tx_control_header_entry_set_f                          f_portmod_rsvd4_tx_control_header_entry_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_rsvd4_tx_control_header_entry_get_f                          f_portmod_rsvd4_tx_control_header_entry_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_rsvd4_tx_single_tunnel_message_config_set_f                  f_portmod_rsvd4_tx_single_tunnel_message_config_set;
#endif /* CPRIMOD_SUPPORT */
    __dispatch__portmod_port_txpi_override_set_f                                     f_portmod_port_txpi_override_set;
    __dispatch__portmod_port_txpi_override_get_f                                     f_portmod_port_txpi_override_get;
    __dispatch__portmod_port_txpi_sdm_data_get_f                                     f_portmod_port_txpi_sdm_data_get;
    __dispatch__portmod_pm_speed_config_validate_f                                   f_portmod_pm_speed_config_validate;
    __dispatch__portmod_pm_vcos_get_f                                                f_portmod_pm_vcos_get;
    __dispatch__portmod_pm_specific_vcos_get_f                                       f_portmod_pm_specific_vcos_get;
    __dispatch__portmod_port_autoneg_ability_advert_set_f                            f_portmod_port_autoneg_ability_advert_set;
    __dispatch__portmod_port_autoneg_ability_advert_get_f                            f_portmod_port_autoneg_ability_advert_get;
    __dispatch__portmod_port_autoneg_ability_remote_get_f                            f_portmod_port_autoneg_ability_remote_get;
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_interrupt_link_status_get_f                        f_portmod_cpri_port_interrupt_link_status_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_interrupt_enable_set_f                             f_portmod_cpri_port_interrupt_enable_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_interrupt_process_f                                f_portmod_cpri_port_interrupt_process;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_fast_clk_bit_time_period_set_f                               f_portmod_fast_clk_bit_time_period_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_fast_clk_bit_time_period_get_f                               f_portmod_fast_clk_bit_time_period_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_1588_bit_time_period_set_f                                   f_portmod_1588_bit_time_period_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_1588_bit_time_period_get_f                                   f_portmod_1588_bit_time_period_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_1588_timestamp_capture_config_set_f                          f_portmod_1588_timestamp_capture_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_1588_timestamp_capture_config_get_f                          f_portmod_1588_timestamp_capture_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_1588_captured_timestamp_get_f                                f_portmod_1588_captured_timestamp_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_1588_timestamp_adjust_set_f                                  f_portmod_1588_timestamp_adjust_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_1588_timestamp_adjust_get_f                                  f_portmod_1588_timestamp_adjust_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_1588_timestamp_fifo_config_set_f                             f_portmod_1588_timestamp_fifo_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_1588_timestamp_fifo_config_get_f                             f_portmod_1588_timestamp_fifo_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_1588_timestamp_cmic_config_set_f                             f_portmod_1588_timestamp_cmic_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_1588_timestamp_cmic_config_get_f                             f_portmod_1588_timestamp_cmic_config_get;
#endif /* CPRIMOD_SUPPORT */
    __dispatch__portmod_port_tx_set_f                                                f_portmod_port_tx_set;
    __dispatch__portmod_port_tx_get_f                                                f_portmod_port_tx_get;
    __dispatch__portmod_port_synce_clk_ctrl_set_f                                    f_portmod_port_synce_clk_ctrl_set;
    __dispatch__portmod_port_synce_clk_ctrl_get_f                                    f_portmod_port_synce_clk_ctrl_get;
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_agnostic_config_set_f                           f_portmod_cpri_port_rx_agnostic_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_agnostic_config_get_f                           f_portmod_cpri_port_rx_agnostic_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_agnostic_config_set_f                           f_portmod_cpri_port_tx_agnostic_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_agnostic_config_get_f                           f_portmod_cpri_port_tx_agnostic_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_encap_presentation_time_config_set_f               f_portmod_cpri_port_encap_presentation_time_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_encap_presentation_time_config_get_f               f_portmod_cpri_port_encap_presentation_time_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_decap_presentation_time_config_set_f               f_portmod_cpri_port_decap_presentation_time_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_decap_presentation_time_config_get_f               f_portmod_cpri_port_decap_presentation_time_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_compression_lookup_table_set_f                     f_portmod_cpri_port_compression_lookup_table_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_compression_lookup_table_get_f                     f_portmod_cpri_port_compression_lookup_table_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_decompression_lookup_table_set_f                   f_portmod_cpri_port_decompression_lookup_table_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_decompression_lookup_table_get_f                   f_portmod_cpri_port_decompression_lookup_table_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_decap_queue_flow_control_set_f                     f_portmod_cpri_port_decap_queue_flow_control_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_decap_queue_flow_control_get_f                     f_portmod_cpri_port_decap_queue_flow_control_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_fec_enable_set_f                                   f_portmod_cpri_port_fec_enable_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_fec_enable_get_f                                   f_portmod_cpri_port_fec_enable_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_fec_timestamp_config_set_f                         f_portmod_cpri_port_fec_timestamp_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_fec_timestamp_config_get_f                         f_portmod_cpri_port_fec_timestamp_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_fec_aux_config_set_f                               f_portmod_cpri_port_fec_aux_config_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_fec_aux_config_get_f                               f_portmod_cpri_port_fec_aux_config_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_ecc_interrupt_enable_set_f                         f_portmod_cpri_port_ecc_interrupt_enable_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_ecc_interrupt_status_get_f                         f_portmod_cpri_port_ecc_interrupt_status_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_init_f                                                  f_portmod_cpri_init;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_rx_gcw_word_get_f                                  f_portmod_cpri_port_rx_gcw_word_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__portmod_cpri_port_tx_gcw_word_set_f                                  f_portmod_cpri_port_tx_gcw_word_set;
#endif /* CPRIMOD_SUPPORT */
    __dispatch__portmod_pm_interrupt_process_f                                       f_portmod_pm_interrupt_process;
    __dispatch__portmod_pm_core_num_get_f                                            f_portmod_pm_core_num_get;
    __dispatch__portmod_port_rlm_config_set_f                                        f_portmod_port_rlm_config_set;
    __dispatch__portmod_port_rlm_config_get_f                                        f_portmod_port_rlm_config_get;
    __dispatch__portmod_port_rlm_status_get_f                                        f_portmod_port_rlm_status_get;
} __portmod__dispatch__t__;

extern __portmod__dispatch__t__* __portmod__dispatch__[portmodDispatchTypeCount];

#endif /*_PORTMOD_DISPATCH_H_*/
